// BEGIN FLOCK GPL
//
// Copyright Flock Inc. 2005-2008
// http://flock.com
//
// This file may be used under the terms of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// END FLOCK GPL

var gUrl;

var faves_coop = Cc["@flock.com/singleton;1"]
                 .getService(Ci.flockISingleton)
                 .getSingleton("chrome://flock/content/common/load-faves-coop.js")
                 .wrappedJSObject;

function getNormalizedURL(url)
{
  // Check to see if the item is a local directory path, and if so, convert
  // to a file URL so that aggregation with rdf:files works
  try {
    const kLF = Components.classes["@mozilla.org/file/local;1"]
                          .createInstance(Components.interfaces.nsILocalFile);
    kLF.initWithPath(url);
    if (kLF.exists()) {
      var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                                .getService(Components.interfaces.nsIIOService);
      var fileHandler = ioService.getProtocolHandler("file")
                                 .QueryInterface(Components.interfaces.nsIFileProtocolHandler);

      url = fileHandler.getURLSpecFromFile(kLF);
    }
  }
  catch (e) {
  }

  return url;
}

function bgPublishAll(servicesBox) {
  if (!servicesBox.hasChildNodes())
    return; // No account => nothing to publish!

  var bookmark = new Bookmark;
  bookmark.URL = getNormalizedURL(gUrl);
  bookmark.name = $("name").value;
  bookmark.tags = $("tags").value;
  bookmark.description = $("description").value;

  var children = servicesBox.childNodes;
  for (var i = 0; i < children.length; i++) {
    var accountItem = children.item(i);
    if (accountItem.checked) {
      var svc = Cc[accountItem.serviceId].getService(Ci.flockIBookmarkWebService);
      svc.publish(null, accountItem.accountId, bookmark, false);
    }
  }
}

function saveShareSettings() {
  var servicesBox = $("bmServices-box");
  var pref_service = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  if(servicesBox.hasChildNodes())
  {
    var children = servicesBox.childNodes;
    for(var i=0; i< children.length; i++)
    {
      var child = children[i];    
      dump('setting the pref !!! ' + child.checked + '\n');
      pref_service.setBoolPref(("flock.favorites.do." + child.serviceId+ "--"+child.accountId),child.checked);
    }
  }
}

function shouldDoEverythingBeSet()
{
  var servicesBox = $("bmServices-box");
  var pref_service = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  var shouldSet = false;
  if(servicesBox.hasChildNodes())
  {
    shouldSet = true;
    var children = servicesBox.childNodes;
    for(var i=0; i< children.length; i++)
    { 
      var child = children[i];
      try
      {
        var prefResult = pref_service.getBoolPref("flock.favorites.do." + child.serviceId+ "--"+child.accountId);
        shouldSet = shouldSet && (child.checked == prefResult);
      }catch(e) {}
    }
  }
  return shouldSet;

}

function loadShareOverlay(aUrl) {
  var servicesBox = $("bmServices-box");
  gUrl = aUrl;
  dump("----- Working with: "+aUrl+"\n");
  // Populate the account list
  var accounts = faves_coop.get('http://flock.com/rdf#AccountsRoot');
  var acctenum = accounts.children.enumerate();
  while (acctenum.hasMoreElements()) {
    var account = acctenum.getNext();
    var svc = Cc[account.serviceId].getService(Ci.flockIWebService);
    try {
      svc.QueryInterface(Ci.flockIBookmarkWebService);
      var accountItem = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "bookmarksAccount");
      accountItem.setAttribute("flex", 1);
      accountItem.setAttribute("label", account.name);
      accountItem.setAttribute("icon", account.favicon);
      accountItem.setAttribute("checked", svc.exists(account.accountId, gUrl));
      accountItem.waschecked = svc.exists(account.accountId, gUrl);
      accountItem.serviceId = account.serviceId;
      accountItem.accountId = account.accountId;
      servicesBox.appendChild(accountItem);
    }
    catch(e) {
      // The account is not on a flockIBookmarkWebService
      // dump(e);
    }
  }
}
