# -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is mozilla.org code.
#
# The Initial Developer of the Original Code is
# Netscape Communications Corporation.
# Portions created by the Initial Developer are Copyright (C) 1998
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

// This is the RDF Resource we're dealing with.
var gResource;
// This is the set of fields that are visible in the window.
var gFields;
// ...and this is a parallel array that contains the RDF properties
// that they are associated with.
var gProperties;
var gSelection;
var gListener;
var gPref_service;
function showDescription()
{
  initServices();
  initBMService();
  gSelection = window.arguments[0];
  gListener = window.arguments[2];
  gResource = RDF.GetResource(gSelection.item[0].Value);

  if (gResource == BMSVC.getBookmarksToolbarFolder()) {
    var description = BookmarksUtils.getLocaleString("description_PersonalToolbarFolder");
    var box = document.getElementById("description-box");
    box.hidden = false;
    var textNode = document.createTextNode(description);
    document.getElementById("bookmarkDescription").appendChild(textNode);
  }
}

function Init()
{
  // assume the user will press cancel (only used when creating new resources)
  window.arguments[1].ok = false;
  // This is the set of fields that are visible in the window.
  gFields     = ["url", "name", "shortcut", "description", "tags", "webpanel", "feedurl"];
  gPref_service = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  // ...and this is a parallel array that contains the RDF properties
  // that they are associated with.
  gProperties = [RDF.GetResource(gNC_NS+"URL"),
                 RDF.GetResource(gNC_NS+"Name"),
                 RDF.GetResource(gNC_NS+"ShortcutURL"),
                 RDF.GetResource(gNC_NS+"Description"),
                 RDF.GetResource(gFL_NS+"tags"),
                 RDF.GetResource(gNC_NS+"WebPanel"),
                 RDF.GetResource(gNC_NS+"FeedURL"),
                 RDF.GetResource(gNC_NS+"GeneratedTitle")];
                 
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
   if(!prefs.getBoolPref("flock.favorites.showKeyword"))
    {
        $("shortcutrow").hidden = true;
    }

  var x;
  // Initialize the properties panel by copying the values from the
  // RDF graph into the fields on screen.

  for (var i=0; i<gFields.length; ++i) {
    var field = document.getElementById(gFields[i]);
    var value = BMDS.GetTarget(gResource, gProperties[i], true);
    
    if (value)
      value = value.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;

    if (gFields[i] == "webpanel")
      field.checked = (value != undefined);
    else if (value) //make sure were aren't stuffing null into any fields
      field.value = value;
  }
  // loadDataForSavedOverlay(gResource, BMDS);
  //if (MicrosummaryPicker.enabled)
  //  MicrosummaryPicker.init();

  var nameNode = document.getElementById("name");
  document.title = document.title.replace(/\*\*bm_title\*\*/gi, nameNode.value);

  // if its a container, disable some things
  var isContainerFlag = RDFCU.IsContainer(BMDS, gResource);
  if (!isContainerFlag) {
    // XXX To do: the "RDFCU.IsContainer" call above only works for RDF sequences;
    //            if its not a RDF sequence, we should to more checking to see if
    //            the item in question is really a container of not.  A good example
    //            of this is the "File System" container.
  }

  var isLivemark = BookmarksUtils.resolveType(gResource) == "Livemark";
  var isSeparator = BookmarksUtils.resolveType(gResource) == "BookmarkSeparator";

  if (isContainerFlag || isSeparator) {
    // Hide the "Load in sidebar" checkbox unless it's a bookmark.
    var webpanelCheckbox = document.getElementById("webpanel");
    webpanelCheckbox.hidden = true;

    // If it is a folder, it has no URL or Keyword and does not need to be saved online
    document.getElementById("locationrow").setAttribute("hidden", "true");
    document.getElementById("shareArea").setAttribute("hidden", "true");
    document.getElementById("tagsrow").setAttribute("hidden", "true");
    document.getElementById("AdvancedFeatures").setAttribute("hidden", "true");
    document.documentElement.getButton("extra1").setAttribute("hidden", "true");
    if (isSeparator) {
      document.getElementById("descriptionrow").setAttribute("hidden", "true");
    }
  }
  else {
    loadShareArea($('bmServices-box'), document.getElementById("url").value, false);
  }

  if (isLivemark) {
    document.getElementById("locationrow").hidden = true;
    document.getElementById("shortcutrow").hidden = true;
    document.getElementById("createlocalcheck").hidden = true;
    document.getElementById("createlocalcheck").checked = true;
    document.getElementById("shareArea").hidden = true;
    document.getElementById("publishLocations").hidden = true;
    document.documentElement.getButton("extra1").setAttribute("hidden", "true");
  } else {
    document.getElementById("feedurlrow").hidden = true;
  }

  var prefsService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  $("showDialog").checked = prefsService.getBoolPref("flock.favorites.starShowProperties");
  sizeToContent();
  
  // set initial focus
  nameNode.focus();
  nameNode.select();
  showParentFolder(gResource);
}
function checkForBookmarkFolderChange()
{
  var coop = Components.classes["@flock.com/singleton;1"]
                       .getService(Components.interfaces.flockISingleton)
                       .getSingleton("chrome://flock/content/common/load-faves-coop.js")
                       .wrappedJSObject;
  var c_oldBM = BookmarksUtils.getflockUtilsObject().BookmarksShareUtils
                          .getCoopObject(BMDS, gResource);
  var isLivemark = BookmarksUtils.resolveType(gResource) == "Livemark";

  var mainParent = null;
  var candidates = c_oldBM.getParents();
  while (candidates.length && !mainParent) {
    var candidate = candidates.pop();
    if (candidate instanceof coop.Folder) // Ignore what's not a folder
      mainParent = candidate;
  }
  if (mainParent && (mainParent.id() !=  $("select-menu").selectedItem.id)) {
    mainParent.children.remove(c_oldBM);
    var newParent = coop.get($("select-menu").selectedItem.id);
    newParent.children.add(c_oldBM);
  }
  BookmarksUtils.flushDataSource();
  BookmarksUtils.refreshSearch();
}
function UpdateBookmark(aUrl)
{
  //TODO: IPAUL need to remove once known not needed
  var coop = Components.classes["@flock.com/singleton;1"]
                       .getService(Components.interfaces.flockISingleton)
                       .getSingleton("chrome://flock/content/common/load-faves-coop.js")
                       .wrappedJSObject;
  // When changing the URL of a bookmark, we are actually changing the URN of
  // that RDF node.  So we need to  re-create the node and transfer all arcs
  // from the old one to the new one.
  var c_oldBM = BookmarksUtils.getflockUtilsObject().BookmarksShareUtils
                              .getCoopObject(BMDS, gResource);
                
  // Is this a regular bookmark or a livemark?
  var isLivemark = BookmarksUtils.resolveType(gResource) == "Livemark";

  if (isLivemark) {
    var mainParent = c_oldBM.getParents()[0];
  } else {
    var mainParent = c_oldBM.getParent();
  }

  // Create the new node under the same parent folder as the old one
  var newBM;
  if (isLivemark) {
    newBM = BMSVC.createLivemark(c_oldBM.name, aUrl, aUrl, "");
  } else {
    newBM = BMDS.addBookmarkToFolder(mainParent.id(), "", aUrl, "", "", "", null, "");
  }
  var c_newBM = BookmarksUtils.getflockUtilsObject().BookmarksShareUtils
                              .getCoopObject(BMDS, newBM);
  if (isLivemark) { mainParent.children.addOnce(c_newBM); }

  // If the old bookmark had multiple parents, make sure they all reference the
  // new bookmark
  var parents = c_oldBM.getParents();
  for (var p in parents) {
    if (parents[p].id() != mainParent.id()) {
      parents[p].children.remove(c_oldBM);
      parents[p].children.add(c_newBM);
    }
  }

  // Now transfer all the bookmark properties
  var bmProps = [ "URL", "capItems", "count", "datevalue", "description",
                  "favicon", "flockType", "hasUnseenItems", "isIndexable",
                  "isPollable", "isTransient", "lastItemDate", "lastQuery",
                  "lastRefresh", "maxItems", "name", "rdftype", "tags",
                  "refreshInterval", "refreshing", "service", "thumbnail",
                  "unseen", "unseenItems", "notify", "state", "FeedURL" ];
  for (var p in bmProps) {
    c_newBM[p] = c_oldBM[p];
  }

  // Destroy the old node, and use the new node from now on
  gResource = RDF.GetResource(c_newBM.id());
  BookmarksUtils.removeSelection("delete", gSelection);  
  c_oldBM.destroy();
  window.arguments[1].gResource = gResource;
}

function Commit()
{
  // Sanitize the URL about to be saved
  var ios = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService(Components.interfaces.nsIIOService);
  try {
    $("url").value = ios.newURI($("url").value, null, null).spec;
  } catch (ex) {
    // Perhaps the user entered a completely invalid URL.  We tried our best to
    // sanitize it, but we don't care enough at this point to raise an error if
    // newURI() failed.
  }

  var changed = false;

  var isLivemark = BookmarksUtils.resolveType(gResource) == "Livemark";
  var publishNeeded = false;
  if (document.getElementById("shareArea").getAttribute("hidden") != "true") {
    var bookmark = new Bookmark();
    bookmark.URL = $("url").value;
    bookmark.name = $("name").value;
    bookmark.tags = $("tags").value;
    bookmark.description = $("description").value;
    publishNeeded = bgPublishAll([bookmark], $("bmServices-box"), gListener);
  }

  for (var i=0; i<gFields.length; ++i) {
    var field = document.getElementById(gFields[i]);

    if (! field)
      continue;

    // Get the new value as a literal, using 'null' if the value is empty.
    var newValue = field.value;

    if (gFields[i] == "webpanel")
      newValue = field.checked ? "true" : undefined;
 
    var oldValue = BMDS.GetTarget(gResource, gProperties[i], true);

    if (oldValue)
      oldValue = oldValue.QueryInterface(Components.interfaces.nsIRDFLiteral);

    if (newValue && gFields[i] == "shortcut") {
      // shortcuts are always lowercased internally
      newValue = newValue.toLowerCase();
      // strip trailing and leading whitespace
      newValue = newValue.replace(/(^\s+|\s+$)/g, '');
    }
    else if (newValue && gFields[i] == "url") {
      if (newValue.indexOf(":") < 0)
        // we're dealing with the URL attribute;
        // if a scheme isn't specified, use "http://"
        newValue = "http://" + newValue;
    }

    if (newValue)
      newValue = RDF.GetLiteral(newValue);

    changed |= updateAttribute(gProperties[i], oldValue, newValue);
    if (gFields[i] == "url" && oldValue && oldValue.Value != newValue.Value) {
      // if the URL was updated, clear out the favicon
      //UpdateBookmark(newValue.Value);
      var icon = BMDS.GetTarget(gResource, RDF.GetResource(gNC_NS+"Icon"), true);
      if (icon) BMDS.Unassert(gResource, RDF.GetResource(gNC_NS+"Icon"), icon);
    }
    if (isLivemark && gFields[i] == "feedurl") {
      var oldVal = (oldValue) ? oldValue.Value : "";
     
      if (oldVal != newValue.Value) {
        UpdateBookmark(newValue.Value);
      }
    }
  }
  // was it asked by the user publish for the first time?
  window.arguments[1].publishedOnline = didUserAskToPublish($("bmServices-box"));
  if (changed) {
    var lastModRes = RDF.GetResource(gWEB_NS+"LastModifiedDate");
    oldValue = BMDS.GetTarget(gResource, lastModRes, true);
    if (oldValue) {
      oldValue = oldValue.QueryInterface(Components.interfaces.nsIRDFDate);
    }
    newValue = RDF.GetDateLiteral ((new Date()).getTime() * 1000);
    updateAttribute(lastModRes, oldValue, newValue);
    // user did not ask to publish for first time however there was changes and
    // that needed to be?
    if (!window.arguments[1].publishedOnline) {
      window.arguments[1].publishedOnline = publishNeeded;
    }
  }

  // Publish/remove to/from bm sharing services
  
  var obs = Components.classes["@mozilla.org/observer-service;1"]
                      .getService(Components.interfaces.nsIObserverService);
  obs.notifyObservers(window,'favorites', 'favorites:update');
  
  window.arguments[1].ok = true;

  if ($("createlocalcheck").checked) {
    checkForBookmarkFolderChange();
  }
  else {
    var c_oldBM = BookmarksUtils.getflockUtilsObject().BookmarksShareUtils
                                .getCoopObject(BMDS, gResource);
    c_oldBM.destroy();
      
    window.close();
    return true;
  }
  // Publish to online service (if needed, and if we're not working on a folder)
  window.close();
  return true;
}

function Cancel()
{
  // Destroy the microsummary picker controller to prevent memory leaks,
  // catching exceptions so we don't prevent the dialog from closing.
  //try {
  //  if (MicrosummaryPicker.enabled)
  //    MicrosummaryPicker.destroy();
  //}
  //catch(e) {
  //  Components.utils.reportError(e);
  //}

  return true;
}

function updateAttribute(aProperty, aOldValue, aNewValue)
{
  if ((aOldValue || aNewValue) && aOldValue != aNewValue) {
    if (aOldValue && !aNewValue)
      BMDS.Unassert(gResource, aProperty, aOldValue);
    else if (!aOldValue && aNewValue)
      BMDS.Assert(gResource, aProperty, aNewValue, true);
    else /* if (aOldValue && aNewValue) */
      BMDS.Change(gResource, aProperty, aOldValue, aNewValue);
    return true;
  }
  return false;
}

function onToggleShowDialog()
{
  var prefsService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  prefsService.setBoolPref("flock.favorites.starShowProperties", $("showDialog").checked);
}

