// BEGIN FLOCK GPL
//
// Copyright Flock Inc. 2005-2008
// http://flock.com
//
// This file may be used under the terms of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// END FLOCK GPL

var faves_coop = Components.classes['@flock.com/singleton;1']
                           .getService(Components.interfaces.flockISingleton)
                           .getSingleton("chrome://flock/content/common/load-faves-coop.js")
                           .wrappedJSObject;
var gUrl;

function getNormalizedURL(url)
{
  // Check to see if the item is a local directory path, and if so, convert
  // to a file URL so that aggregation with rdf:files works
  try {
    const kLF = Components.classes["@mozilla.org/file/local;1"]
                          .createInstance(Components.interfaces.nsILocalFile);
    kLF.initWithPath(url);
    if (kLF.exists()) {
      var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                                .getService(Components.interfaces.nsIIOService);
      var fileHandler = ioService.getProtocolHandler("file")
                                 .QueryInterface(Components.interfaces.nsIFileProtocolHandler);

      url = fileHandler.getURLSpecFromFile(kLF);
    }
  }
  catch (e) {
  }

  return url;
}

function Bookmark() {
  this.URL = "";
  this.name = "";
  this.description = "";
  this.tags = "";
  this.time = "";
}

Bookmark.prototype = {
  getInterfaces: function (count) {
    var interfaceList = [Components.interfaces.flockIBookmark, Components.interfaces.nsIClassInfo];
    count.value = interfaceList.length;
    return interfaceList;
  },
  QueryInterface: function (iid) {
    if (!iid.equals(Components.interfaces.flockIBookmark))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  },
  getHelperForLanguage: function (count) {return null;}
}

function simpleEnumerator (aArray) {
  this.data = aArray;
}

simpleEnumerator.prototype = {
  hasMoreElements: function () { 
    return this.data.length != 0; 
  },
  getNext: function () { 
    return this.data.shift (); 
  },
  getInterfaces: function (count) {
    var interfaceList = [Components.interfaces.nsISimpleEnumerator, Components.interfaces.nsIClassInfo];
    count.value = interfaceList.length;
    return interfaceList;
  },
  QueryInterface: function (iid) {
    if (!iid.equals(Components.interfaces.nsISimpleEnumerator))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  },
  getHelperForLanguage: function (count) {return null;}
}


// TODO:
//  * Get the right name/description for each tab
//  * add a publishList in the backend to publish a list of url
//  * wait one second between each call (or do a batch publish)
function bgPublishAll(aBookmarkList, servicesBox, aListener) {
  if (!servicesBox.hasChildNodes()) {
    // No account => nothing to publish!
    return false;
  }
  var neededToPublish = false;
  var children = servicesBox.childNodes;
  for (var i = 0; i < children.length; i++) {
    // the first child will be the accountItem, ignore the parent
    var accountItem = children.item(i).firstChild;
    if (accountItem.checked) {
      var svc = Cc[accountItem.serviceId]
                .getService(Ci.flockIBookmarkWebService);
      svc.publishList(aListener, accountItem.accountId,
                      new simpleEnumerator(aBookmarkList.concat()),
                      accountItem.getPrivate());
      neededToPublish = true;
    }
  }
  return neededToPublish;
}

function saveShareSettings() {
  var servicesBox = $("bmServices-box");
  var pref_service = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  if(servicesBox.hasChildNodes()) {
    var children = servicesBox.childNodes;
    for(var i=0; i< children.length; i++) {
      var child = children[i];
      if(child.localName == 'row')
      {
        child = child.firstChild;
      }    
      pref_service.setBoolPref(("flock.favorites.do." + child.serviceId+ "--"+child.accountId), child.checked);
      pref_service.setBoolPref(("flock.favorites.private." + child.serviceId+ "--"+child.accountId), child.getPrivate());
    }
  }
}
function loadShareSettings()
{
  var servicesBox = $("bmServices-box");
  var pref_service = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  var haveShared = false;
   if(servicesBox.hasChildNodes()) {
     var children = servicesBox.childNodes;
     for(var i=0; i< children.length; i++) {
       var child = children[i];
       if(child.localName == 'row')
       {
         child = child.firstChild;
       }
       try
       {
        child.checked = pref_service.getBoolPref("flock.favorites.do." + child.serviceId+ "--"+child.accountId);
        child.private = pref_service.getBoolPref("flock.favorites.private." + child.serviceId+ "--"+child.accountId);
        child.myToggleCheckBox();
        haveShared = true;
       }catch(e){}    
     }
   }
     return haveShared;
 }

function didUserAskToPublish(aServicesBox) {
  var children = aServicesBox.childNodes;
  var userAsked = false;
  for (var i = 0; i < children.length; i++) {
    var accountItem = children.item(i).firstChild;
    if (accountItem.checked &&
        accountItem.toggleOccurred) {
      // accountItem was checked by user
      userAsked = true;
      break;
    }
  }
  return userAsked;
}

function getFolderBookmarksRecurse(aCoopObj, aTags) {
  var bookmarks = [];
  var elems = aCoopObj.children.enumerate();
  while (elems.hasMoreElements()) {
    var folder_item = elems.getNext();
    if (folder_item.flockType == "folder") {
      bookmarks =
        bookmarks.concat(getFolderBookmarksRecurse(folder_item, aTags));
    } else {
      bookmarks.push(getBookmarkFromCoopObj(folder_item, aTags));
    }
  }
  
  return bookmarks;
}

function getBookmarkFromCoopObj(aCoopObj, aTags) {
  var bookmark = new Bookmark;
  bookmark.URL = aCoopObj.URL;
  bookmark.name = aCoopObj.name;
  bookmark.description = aCoopObj.description;
  bookmark.tags = aCoopObj.tags + " " + aTags;

  return bookmark;
}

function publishOnline(aService, accoundId, items, tags) {
  var acUtils = Components.classes["@flock.com/account-utils;1"]
                          .getService(Components.interfaces.flockIAccountUtils);
  var accounts = acUtils.getAccountsByInterface("flockIBookmarkWebService");

  var bookmarks = [];
  for (i in items) {
    var coopitem = faves_coop.get_from_resource(items[i]);
    if (coopitem.flockType == "folder") {
      bookmarks = bookmarks.concat(getFolderBookmarksRecurse(coopitem, tags));
    } else {
      bookmarks.push(getBookmarkFromCoopObj(coopitem, tags));
    }
  }

  while (accounts.hasMoreElements()) {
    var account = accounts.getNext().QueryInterface(Components.interfaces.flockIWebServiceAccount);
    var c_acct = faves_coop.get(account.urn);
    if (c_acct.serviceId.indexOf(aService > -1) && c_acct.accountId == accoundId) {
      var svc = Components.classes[c_acct.serviceId].getService(Components.interfaces.flockIWebService);
      svc.QueryInterface(Components.interfaces.flockIBookmarkWebService);

      var listener = {
        onSuccess: function (aSubject, aTopic) {
          dump('we published !!!\n');
        },
        onError: function (aSubject, aTopic, aError) {
          alert("Error publishing to your bookmark service");
        }
      }
      svc.publishList(listener, c_acct.accountId, new simpleEnumerator(bookmarks), false);
      break;
    }
  }
}

function saveOnlineBookmarkLocally(item, parent)
{
  
  var coopitem    = faves_coop.get_from_resource(item);
  var uri = coopitem.id()
  var urlIndex = uri.indexOf("http://");
  var url = uri.substring(urlIndex, uri.length);
  var resource = BMDS.addBookmarkToFolder(parent, coopitem.name, url, '', 
                                    coopitem.description, '', 
                                    '',coopitem.tags);
  return BookmarksUtils.getSelectionFromResource(resource);
}
function loadShareArea(servicesBox, aUrl, preCheck) {
  var prefsService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  gUrl = aUrl;
  // Populate the account list
  var acUtils = Components.classes["@flock.com/account-utils;1"]
                          .getService(Components.interfaces.flockIAccountUtils);
  var accounts = acUtils.getAccountsByInterface("flockIBookmarkWebService");
  var isShared = false;
  if(accounts.hasMoreElements()) {
    $("shareArea").setAttribute('hidden', false);
  }else
  {
    $("createlocalcheck").setAttribute("disabled", true);
    $("createlocalcheck").setAttribute("checked", true);
  }
  while (accounts.hasMoreElements()) {
    var row =  document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "row");
    row.setAttribute('align', "center");
    servicesBox.appendChild(row);
    var account = accounts.getNext().QueryInterface(Components.interfaces.flockIWebServiceAccount);
    var c_acct = faves_coop.get(account.urn);
    var svc = Cc[c_acct.serviceId].getService(Ci.flockIWebService);
    try {
      svc.QueryInterface(Ci.flockIBookmarkWebService);
      var accountItem = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "bookmarksAccount");
      accountItem.setAttribute("flex", 1);
      accountItem.setAttribute("icon", c_acct.favicon);
      accountItem.setAttribute("value", c_acct.name);      
      accountItem.serviceId = c_acct.serviceId;
      accountItem.accountId = c_acct.accountId;
      accountItem.id = c_acct.accountId + "-" + c_acct.serviceId;
      row.appendChild(accountItem);
      if (svc.exists(c_acct.accountId, gUrl))
      {
        var bookmark = faves_coop.get(svc.urn+":"+accountItem.accountId+':'+gUrl);
        var date = "Last published date unavailable";
        var dateString = null;
        if(bookmark.LastModifiedDate)
        {  
          var myDate= new Date(bookmark.LastModifiedDate);
          dateString = myDate.toLocaleString();          
        }else if(bookmark.datevalue)
        {
          var myDate= new Date(bookmark.datevalue);
          dateString = myDate.toLocaleString();
        } 
       if(dateString)
       {
         var dateArray = dateString.split(' ');
          if(dateArray.length == 5)
            date = dateArray[1] + ' ' + dateArray[2] + ',  ' + dateArray[4]; 
         else if(dateArray.length > 5)
#ifdef XP_MACOSX
           date = dateArray[1] + ' ' + dateArray[3] + ',  ' + dateArray[5];
#else
            date = dateArray[1] + ' ' + dateArray[2] + ' ' + dateArray[3];
#endif
       }
        accountItem.setAttribute("publishDate",date);
        setTimeout("$('" + accountItem.id   +"').myToggleCheckBox()", 0);
        accountItem.setAttribute("checked", true);
        accountItem.setAttribute("private", bookmark.private);
        accountItem.setAttribute("privateStatus", bookmark.private);
        isShared = true
       }  
      
    }
    catch(e) {
      // The account is not on a flockIBookmarkWebService
       dump(e);
    }
  }
  return isShared;
}
