// BEGIN FLOCK GPL
//
// Copyright Flock Inc. 2005-2008
// http://flock.com
//
// This file may be used under the terms of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// END FLOCK GPL

function flock_blogBrowserSetupEditorCommands() {
    var controller = new CommandController();
    controller.cmd_flock_blogBlogThis = flock_blogBlogThisCommand;
    controller.cmd_flock_blogNewPost = flock_blogNewPost;

    top.controllers.appendController(controller);
    // TO - do not call top.focus(), in XP it throws the window
    //      into a confused state.
    //top.focus();
}


var blogButtonDNDObserver = {
  canHandleMultipleItems: true,

  onDragOver: function(aEvent, aFlavor, aSession) {
  },

  onDragEnter: function(aEvent, aSession) {
  },

  onDragExit: function(aEvent, aSession) {
  },

  onDrop: function(aEvent, aDropData, aSession) {
    dump("drop!\n");
    var dropData = aDropData.dataList[0].dataList[0];
    
    var supports = dropData.supports;
    var contentType = dropData.flavour.contentType;
    var url;

    dump(contentType+"\n");

    if (contentType == "application/x-moz-file") {
      // File: if it's a photo, try to upload it
      try {
        var file = supports.QueryInterface(Components.interfaces.nsIFile);
        url = flock_photo.util.getURLFromFile(file);
      } catch(e) {}

      if (!flock_photouploader.service.hasOnePhotoAccount()) {
        flock_photouploader.service.promptForAccount();
        return;
      }

      var editWindow = flock_blog.service.openEditor(null, null, null);
      var photoUploadListener = {
        onMediaImportStart: function(aFilename, aCount) {
        },

        onMediaImportFinish: function(aUpload, aCount) {
          flock_photo.util.launchSinglePhotoUpload(aUpload, editWindow.document.getElementById('edit'));
       },

        onMediaImportError: function (aFilename) {
          var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                .getService(Components.interfaces.nsIPromptService);
          promptService.alert(editWindow, 'The photo "' + aFilename + '" could not be uploaded because it is invalid.');
        }
      }
      flock_photouploader.service.importSingleMediaItem(photoUploadListener, url);
    }
    else {
      // Not a file: fall back to the usual "blog this" like stuff
      var dropped = flock_getMarkedUpSelection(aSession).content+"\n";
      flock_blog.service.openEditor(null, dropped, null);
      
    }
  },

  onDragStart: function(aEvent, aTransferData, aAction) {},

  getSupportedFlavours: function() {
    var flavors = new FlavourSet();
    flavors.appendFlavour("application/x-flock-rich-content");
    flavors.appendFlavour("text/html");
    flavors.appendFlavour("application/x-moz-file", "nsIFile");
    return flavors;
  }
}

window.addEventListener("load", flock_blogBrowserSetupEditorCommands, false);
