// BEGIN FLOCK GPL
//
// Copyright Flock Inc. 2005-2008
// http://flock.com
//
// This file may be used under the terms of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// END FLOCK GPL

const FLOCK_DEFAULT_FEEDS_OPML = "chrome://flock/locale/feeds/opml/default.opml";

var firstRunOverlay = {};

firstRunOverlay.wizardFinished = function() {
    dump ("foofoo: wizard has finished. Gonna reload tabs\n");
    if (this.firstRunUrl) gBrowser.addTab(this.firstRunUrl);
    gBrowser.mCurrentBrowser.loadURI(gBrowser.mCurrentBrowser.currentURI.spec + "?");

    // JMC - Time for A/B test
    if ( flock_getBoolPref('browser.stats.sendAnonymous') &&
        !flock_getCharPref('flock.photo.preferredServices') &&
        (flock_getIntPref('flock.first_run.date') % 2) )
    {
        flock_topbarSelectById('flock_PhotoBrowseTopbarBroadcaster', true);
        var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                            .createInstance(Components.interfaces.nsIXMLHttpRequest);
        req.open('GET', brandingUtilities.buildWebsiteUrl('browser', 'firstrun', 'photobarOpened', 'none'), true);
        req.send(null);
    }
}

top.addEventListener("load", function() {
    var firstRunForBrowser = flock.firstrun.isFirstRunForComponent("browser_startup");
    var firstRunForFeeds = flock.firstrun.isFirstRunForComponent("feeds_startup");    
    if (firstRunForBrowser) {
        var aus = Components.classes["@mozilla.org/updates/update-service;1"]
             .getService(Components.interfaces.nsIApplicationUpdateService);
        aus.startupPing();

        var faves = Components.classes['@flock.com/favorites-service;1']
             .getService(Components.interfaces.flockIFavoritesService);
        faves.setupDefaultFavorites();
    }

    if (firstRunForFeeds) {
        feedUtils.loadFeedsFromLocalOPML(FLOCK_DEFAULT_FEEDS_OPML);
    }

    updateWebDetectiveFiles();
}, false);

function updateWebDetectiveFiles() {
#if BUILD_ID!=0000000000
  if (!checkForPref("flock.webdetective.upgraded")) {
    var wd = Components.classes["@flock.com/web-detective;1"]
                       .getService(Components.interfaces.flockIWebDetective);
    wd.checkForUpdates(true, null);

    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefBranch);
    prefs.setBoolPref("flock.webdetective.upgraded", true);
  }
#endif
}

function checkForPref(aPrefName)
{
    var prefSVC = Components.classes['@mozilla.org/preferences-service;1']
                            .getService(Components.interfaces.nsIPrefBranch);
    return (prefSVC.getPrefType(aPrefName) && prefSVC.getBoolPref(aPrefName));
}

function revertToOriginalToolbar() {
    var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
        getService(Components.interfaces.nsIRDFService);
    var ds = rdfService.GetDataSource("rdf:local-store");
    var node = rdfService.GetResource("chrome://browser/content/browser.xul#nav-bar");
    var props=ds.ArcLabelsIn(node);
    while(props.hasMoreElements()){
        var prop=props.getNext();
        var source=ds.GetSource(prop,node,true);
        ds.Unassert(source,prop,node);
    }
}

function checkIfBuzzardUpgrade() {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefBranch);

    // LOGIC: we only are doing a buzzard upgrade if the key doesn't exist
    try {
        var browserStartupKey = "flock.firstrun.components.browser_startup.completed";
        var feedsStartupKey = "flock.firstrun.components.feeds_startup.completed";
        var browserKeyExists = prefs.getBoolPref(browserStartupKey);
        prefs.getBoolPref(feedsStartupKey);
    } catch (ex) {
        if (browserKeyExists) {
            revertToOriginalToolbar();            // Buzzard upgrade if the browser first run ran, but feeds first run has not
        }
    }
}

checkIfBuzzardUpgrade();

function incrementFlockLaunchCount(){
  var launchCount = flock_getIntPref("flock.launch_count");
  launchCount += 1;
  flock_setIntPref("flock.launch_count",launchCount);
}

incrementFlockLaunchCount();
