// BEGIN FLOCK GPL
//
// Copyright Flock Inc. 2005-2008
// http://flock.com
//
// This file may be used under the terms of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// END FLOCK GPL

Components.utils.import("resource:///modules/FlockStringBundleHelpers.jsm");

// no ui code should be loaded into services
var FLOCKDEBUG = 1;

var flock = {/*{{{*/
};/*}}}*/

try {
    var working_debug = debug;
} catch (e) {
    var working_debug = dump;
}

flock.lang = {/*{{{*/
    // you are searching for beauty
    // in all the wrong places
};/*}}}*/

flock.lang.toArray = function () {/*{{{*/
    var iterable = arguments[0];
    var out = [];
    if (arguments.length > 1) {
        iterable = arguments;
    }
    // check for nsISimpleEnumerator
    if (iterable['hasMoreElements']) {
        while (iterable.hasMoreElements()) {
            out.push(iterable.getNext());
        }
    }
    else {
        for (var i = 0; i < iterable.length; ++i) {
            out.push(iterable[i]);
        }
    }
    return out;
};/*}}}*/

var XXX = function () {/*{{{*/
    if (!FLOCKDEBUG) return;
	var out = ''
	if (arguments.length > 1) {
		for (var i = 0;i < arguments.length;i++) {
			out += arguments[i] + " : ";
		}
	} else {
		out = "DEBUG : "+arguments[0];
	}
	working_debug(out+"\n");
}/*}}}*/
var dd = function (aObj) {/*{{{*/
	for (p in aObj) {
		try {
			working_debug(p + ' :: ' + aObj[p] + '\n'); 
			if (typeof aObj[p] == 'aObject') { 
				for (q in aObj[p]) { 
					working_debug(p + '.' + q + ' :: ' + aObj[p][q] + '\n'); 
				} 
			}
		} catch(e) {
			continue;
		}
	}
};/*}}}*/

flock.browser = {/*{{{*/
    // what shall we do when all is gone?
    // sail on, sail on
    // sail on and on
};/*}}}*/

// Services
function flock_getPrefService() {
    return Components.classes['@mozilla.org/preferences-service;1']
        .getService(Components.interfaces.nsIPrefBranch);
}

// Preferences
function flock_clearPref(aKey) {/*{{{*/
	var prefService = flock_getPrefService();
	prefService.clearUserPref(aKey);
	prefService.deleteBranch(aKey);
}/*}}}*/
function flock_getCharPref(aKey) {/*{{{*/
    try {
        return flock_getPrefService().getCharPref(aKey);
    } catch (e) {
        return;
    }
}/*}}}*/
function flock_setCharPref(aKey, aValue) {/*{{{*/
    flock_getPrefService().setCharPref(aKey, aValue);
}/*}}}*/
function flock_getIntPref(aKey) {/*{{{*/
    try {
        return flock_getPrefService().getIntPref(aKey);
    } catch (e) {
        return;
    }
}/*}}}*/
function flock_setIntPref(aKey, aValue) {/*{{{*/
    flock_getPrefService().setIntPref(aKey, aValue);
}/*}}}*/
function flock_getBoolPref(aKey) {/*{{{*/
    try {
        return flock_getPrefService().getBoolPref(aKey);
    } catch (e) {
        return;
    }
}/*}}}*/
function flock_setBoolPref(aKey, aValue) {/*{{{*/
    flock_getPrefService().setBoolPref(aKey, aValue);
}/*}}}*/

// Javascript Extensions
function $(aElementName) {/*{{{*/
	return document.getElementById(aElementName);
}/*}}}*/
function $$(aElementName) {/*{{{*/
	return top.document.getElementById(aElementName);
}/*}}}*/

flock.browser = {/*{{{*/
    // what shall we do when all is gone?
    // sail on, sail on
    // sail on and on
};/*}}}*/

flock.browser.parseQuery = function (aURL) {/*{{{*/
    var m = aURL.match(/.*\?(.*)/);
    if (!m) return {}
    var qs = m[1].split("&");
    var o = {};
    qs.forEach(function (aVal) {
        var kv = aVal.split("=");
        o[unescape(kv[0])] = unescape(kv[1]);
    });
    return o;
}/*}}}*/


function openFlockPreferences(aServiceId) {
#ifdef XP_MACOSX
  var opts = 'chrome,titlebar,toolbar,centerscreen,dialog=no';
#else
  var opts = 'chrome,all,centerscreen';
#endif
  var windowsMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
      .getService(Components.interfaces.nsIWindowMediator);
  var recent = windowsMediator.getMostRecentWindow("AccountPreferences");
  if(recent) {
    if(aServiceId)
      recent.loadService(aServiceId);
    recent.focus();
  }
  else {
    window.openDialog("chrome://flock/content/common/accountManagement.xul",
        "AccountPreferences", opts, { serviceid: aServiceId});
  }
}

// copies goDoCommand but passes all extra arguments
flock.command = function (aCmd) {/*{{{*/
    var args = flock.lang.toArray(arguments);
    args.shift();
    XXX('flock.command', args);
    var _this = this;
    try {
        var controller = top.document.commandDispatcher
            .getControllerForCommand(aCmd);
        if (controller && controller.isCommandEnabled(aCmd)) {
            flock.command.context = args;
            controller.doCommand(aCmd);
            flock.command.context = null;
        }
    }
    catch (e) {
        XXX("Error while executing command", aCmd);
        dd(e);
    }
}/*}}}*/

flock.command.context = null;

CommandController = function(){};

CommandController.prototype = {
    isDebug: false,
    debugCommands: null,
    getFunctor: function(aCmd) {
        if (aCmd in this) return this[aCmd];
        return;
    },
    supportsCommand: function(aCmd) {
        if (this.isDebug) {
            var r = (this.debugCommands.indexOf(aCmd) != -1 || this[aCmd] != null);
            return r;
        }
        return (this[aCmd] != null);
    },
    isCommandEnabled: function(aCmd) {
        if (this.isDebug) {
            if (this[aCmd]) {
                if ("isEnabled" in this[aCmd]) r = this[aCmd].isEnabled();
                else r = true;
            }
            else r = (this.debugCommands.indexOf(aCmd) != -1);
            XXX('isEnabled', aCmd, r);
            return r;
        }
        var f = this[aCmd];
        if (typeof this[aCmd] == "object" && "isEnabled" in this[aCmd]) return this[aCmd].isEnabled();
        return true;
    },
    doCommand: function(aCmd) {
        if (this[aCmd]) {
            if (typeof this[aCmd] == "object" 
                && "exec" in this[aCmd]) 
                return this[aCmd].exec.apply(this, flock.command.context);
            return this[aCmd].apply(this, flock.command.context);
        }
        return;
    },
    doCommandWithParams: function(aCmd, aEnum) {
        var params = flock.lang.toArray(aEnum);
        if (this[aCmd]) {
            if (typeof this[aCmd] == "object" 
                && "exec" in this[aCmd]) 
                return this[aCmd].exec.apply(this, params);
            return this[aCmd].apply(this, params);
        }
        return;
    },
    onEvent: function(aEvent) { }
};
