//
// BEGIN FLOCK GPL
//
// Copyright Flock Inc. 2005-2008
// http://flock.com
//
// This file may be used under the terms of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// END FLOCK GPL
//

// the default object definitions for the Favorites datastore
// passed into this environment are Coop (the type) and coop (the instance)

const FLOCK_NS = 'http://flock.com/rdf#';
const NSCP_NS = 'http://home.netscape.com/NC-rdf#';
const RDF_NS = 'http://www.w3.org/1999/02/22-rdf-syntax-ns#';
const WEB_NS = 'http://home.netscape.com/WEB-rdf#';
const FOAF_NS = 'http://xmlns.com/foaf/0.1/';

coop.FoafPerson = coop.add_type (FOAF_NS+'Person', {
	fields: { 
		nick: FOAF_NS+'nick',
		knows: FOAF_NS+'knows',
		seeAlso: RDF_NS+'seeAlso',
		aimChatID: FOAF_NS+'aimChatID',
		icqChatID: FOAF_NS+'icqChatID',
		msnChatID: FOAF_NS+'msnChatID',
		img: FOAF_NS+'img',
		dateOfBirth: FOAF_NS+'dateOfBirth',
		homepage : FOAF_NS+'homepage',
    rdftype: RDF_NS + 'type',
	},
	field_types: { 
		knows: Coop.object,
		seeAlso: Coop.resource,
		img: Coop.resource,
		homepage: Coop.resource,
		rdftype: Coop.resource,
	},
	field_defaults: {
	  rdftype: FOAF_NS+'Person',
	},
	field_multiple: {
		knows: true,
	},
});
	
