const Cc = Components.classes;
const Ci = Components.interfaces;

var faves_coop = Cc["@flock.com/singleton;1"]
                 .getService(Ci.flockISingleton)
                 .getSingleton("chrome://flock/content/common/load-faves-coop.js")
                 .wrappedJSObject;

function onLoad() {
  // Populate the fields related to the bookmark
  var bookmark = window.arguments[0].bookmark;
  $("url").value = bookmark.URL;
  $("title").value = bookmark.name;

  // Populate the account list
  var accts = $("account-selector");
  var accounts = faves_coop.get('http://flock.com/rdf#AccountsRoot');
  var enum = accounts.children.enumerate();
  while (enum.hasMoreElements()) {
    var account = enum.getNext();
    if (!account) continue; // getNext() can return NULL when hasMoreElements() is TRUE.
    var svc = Cc[account.serviceId].getService(Ci.flockIWebService);
    try {
      svc.QueryInterface(Ci.flockIBookmarkWebService);
      var item = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "listitem");
      item.setAttribute("class", "listitem-iconic");
      item.setAttribute("id", account.id());
      item.setAttribute("label", account.name);
      item.setAttribute("image", account.favicon);
      item.setAttribute("oncommand", "onAccept();");
      item.setAttribute("ondblclick", "onAccept();");
      item.accountId = account.accountId;
      item.svc = svc;
      accts.appendChild(item);
    }
    catch(e) {
      // The account is not on a flockIBookmarkWebService
    }
  }

  accts.selectedIndex = 0; 
}

function onAccept() {
  var account = $("account-selector").selectedItem;
  var bookmark = window.arguments[0].bookmark;
  bookmark.URL = $("url").value;
  bookmark.name = $("title").value;
  bookmark.tags = $("tags").value;

  var listener = {
    onSuccess: function (aSubject, aTopic) {
      dump(" --- Successful publication\n");
      window.close();
    },
    onError: function (aSubject, aTopic, aError) {
      document.documentElement.getButton("accept").setAttribute("disabled", "false");
      document.documentElement.getButton("cancel").setAttribute("disabled", "false");
      var msg = flockGetString("favorites/favorites", "flock.favs.overlay.publish.error");
      alert(msg);
    }
  }

  document.documentElement.getButton("accept").setAttribute("disabled", "true");
  document.documentElement.getButton("cancel").setAttribute("disabled", "true");
  account.svc.publish(listener, account.accountId, bookmark);

  // Don't close yet (dialog will be close by the listener)
  return false;
}
