/*
 * BEGIN FLOCK GPL
 *
 * Copyright Flock Inc. 2005-2008
 * http://flock.com
 *
 * This file may be used under the terms of the
 * GNU General Public License Version 2 or later (the "GPL"),
 * http://www.gnu.org/licenses/gpl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * END FLOCK GPL
 */

// This needs to be included before nsIGenericFactory.h, since on windows
// it pulls in windef.h which screws things up in the lucene headers
#include "flockLuceneImpl.h"

#include "nsIGenericFactory.h"
#include "flockLuceneCID.h"

#include "flockLucene.h"


NS_GENERIC_FACTORY_CONSTRUCTOR(flockLucene)
NS_GENERIC_FACTORY_CONSTRUCTOR(flockLuceneImpl)

static nsModuleComponentInfo components[] =
{
    {
       FLOCK_LUCENE_CLASSNAME, 
       FLOCK_LUCENE_CID,
       FLOCK_LUCENE_CONTRACTID,
       flockLuceneConstructor,
    },

    {
       FLOCK_LUCENE_IMPL_CLASSNAME, 
       FLOCK_LUCENE_IMPL_CID,
       FLOCK_LUCENE_IMPL_CONTRACTID,
       flockLuceneImplConstructor,
    },

    {0}
};

NS_IMPL_NSGETMODULE(LuceneModule, components)


