/*
 * BEGIN FLOCK GPL
 *
 * Copyright Flock Inc. 2005-2008
 * http://flock.com
 *
 * This file may be used under the terms of the
 * GNU General Public License Version 2 or later (the "GPL"),
 * http://www.gnu.org/licenses/gpl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * END FLOCK GPL
 */

#ifndef __flockLuceneThread_h__
#define __flockLuceneThread_h__

#include "nsCOMPtr.h"

#include "nsString.h"

#include "nsISupports.h"
#include "nsIRunnable.h"
#include "nsIThread.h"
#include "nsIEventQueue.h"

#include "prmon.h"


#include "flockILucene.h"

class flockLuceneThread : public nsIRunnable {
public:
    flockLuceneThread ();
    virtual ~flockLuceneThread ();

    NS_DECL_ISUPPORTS
    NS_DECL_NSIRUNNABLE

	  nsresult Init(nsIFile* aTarget);
    nsresult GetProxyAsync(flockILucene **aProxy);
    nsresult GetProxySync(flockILucene **aProxy);
	  nsresult Shutdown();

private:
    // Initialize the lucene indexer
    void InitializeLucene ();

    nsCOMPtr<nsIThread> mThread;

    nsCOMPtr<nsIEventQueue> mEventQueue;

    nsCOMPtr<flockILucene> mProxyAsync;
    nsCOMPtr<flockILucene> mProxySync;

    PRLock *mLock;
    PRMonitor *mMonitor;

    nsCOMPtr<nsIFile> mIndexDir;

    bool mRunning;
};



#endif
