// BEGIN FLOCK GPL
//
// Copyright Flock Inc. 2005-2008
// http://flock.com
//
// This file may be used under the terms of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// END FLOCK GPL

var mediabar = {
  _favsCoop : Components.classes['@flock.com/singleton;1']
                           .getService(Components.interfaces.flockISingleton)
                           .getSingleton("chrome://flock/content/common/load-faves-coop.js")
                           .wrappedJSObject,
  load: function(aAccount) {
    mediabar.ensureOpen();
    var acctCoop = mediabar._favsCoop.get(aAccount.urn);
    if (acctCoop) {
      var serviceId = acctCoop.serviceId;
      if (serviceId && serviceId.length) {
        var svc = Components.classes[serviceId].getService(Components.interfaces.flockIMediaWebService);
        
        if (TopbarJSCtx().gPhotoDrawer) {
          TopbarJSCtx().gPhotoDrawer.loadPhotoPerson(aAccount.urn, svc.shortName);
        }
        else {
          TopbarJSCtx().initialMedia = { person: {
            urn: aAccount.urn,
            svc: svc.shortName
          }}
        }
      }
    }
  },
  loadQuery: function(aService, aQuery, aName) {
    mediabar.ensureOpen();
    if (TopbarJSCtx().gPhotoDrawer) {
      TopbarJSCtx().gPhotoDrawer.mFilter = '';
      TopbarJSCtx().gPhotoDrawer.loadQuery( aService, aQuery, aName );
      TopbarJSCtx().gPhotoDrawer.emptySearchbox();
    }
    else {
      TopbarJSCtx().initialMedia = { query: {
        service: aService,
        query: aQuery,
        name: aName
      }}
    }
  },
  loadFromId: function(aId) {
    mediabar.ensureOpen();
    if (TopbarJSCtx().gPhotoDrawer) {
      TopbarJSCtx().gPhotoDrawer.loadFromId( aId );
    }
    else {
      var item = mediabar._favsCoop.get(aId);
      TopbarJSCtx().initialMedia = { query: {
        service: item.service,
        query: item.query,
        name: item.name 
      }}
    }
  },
  showActionMessage: function(aMessage) {
    mediabar.ensureOpen();
    if (TopbarJSCtx().gPhotoDrawer) {
      TopbarJSCtx().gPhotoDrawer.showActionMessage(aMessage);
    } else {
      // The mediabar is not initialized yet:
      // set a variable that will be picked up at initialization
      TopbarJSCtx().gInitialActionMessage = aMessage;
    }
  },
  hideActionMessage: function() {
    if (TopbarJSCtx().gPhotoDrawer) {
      TopbarJSCtx().gPhotoDrawer.hideActionMessage();
    }
  },
  lock: function()
  {
    mediabar.ensureOpen();
    var retval = true;
    if (TopbarJSCtx().gPhotoDrawer) {
      retval = TopbarJSCtx().gPhotoDrawer.lock();
    }
    return retval;
  },
  unlock: function()
  {
    if (TopbarJSCtx().gPhotoDrawer) 
    {
      TopbarJSCtx().gPhotoDrawer.unlock();
    }
  },
  ensureOpen: function() {
    flock_topbarSelectById('flock_MediabarTopbarBroadcaster', true)
  },
  
  needDiscovery: function(aBrowser, aService, aQuery, aUrl)
  {
    var showDiscovery = true;
   // if the topbar is open with mediabar
    if ($("topbarBrowser").getAttribute("src") && TopbarJSCtx().gPhotoDrawer) {
      if ( (TopbarJSCtx().gPhotoDrawer.mApi == aService) && (TopbarJSCtx().gPhotoDrawer.mQuery.stringVal == aQuery) ) {
        showDiscovery = false;
        var nBox = aBrowser.getNotificationBox();
        nBox.saveToHashtable(aUrl, nBox.FLOCK_PRIORITY_LOW);
      }
    }
    return showDiscovery;
  }
};
