//
// BEGIN FLOCK GPL
//
// Copyright Flock Inc. 2005-2008
// http://flock.com
//
// This file may be used under the terms of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// END FLOCK GPL
//

var gPhoto;
var gSelectedApi;
var gPhotoMgrSvc;
var gPrefSvc;
var gTarget;
var gApiListener;

function init() {
  // need to wrap in an array :/
  var uploadItems = Array();
  gPhoto = window.arguments[0].aPhoto;
  uploadItems.push(gPhoto);
  photoProperties.setUploadType(UPLOAD_TYPE_DND);
  photoProperties.setSelection(uploadItems);
  gTarget = window.arguments[0].aTarget;
  gPhotoMgrSvc = Components.classes['@flock.com/photo-api-manager;1?'].getService(Components.interfaces.flockIPhotoAPIManager);
  gPrefSvc = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);

  $('batch-radio').collapsed = true;

  flock_photo.util.populateServicesPopup($('servicesMenuList').firstChild); 

  gApiListener = {
    onAPIStateChange: function(aAPI) {
      flock_photo.util.populateServicesPopup($('servicesMenuList').firstChild);
    }
  }

  gPhotoMgrSvc.addListener(gApiListener);
}

function unload() {
  gPhotoMgrSvc.removeListener(gApiListener);
}

function flock_updateSelectedAPI() {
  var selectedApi = $("flockPhotoservicesList").value;
  if (selectedApi) {
    gSelectedApi = gPhotoMgrSvc.getAPIFromShortname($("flockPhotoservicesList").value);
    $('bcasterServiceUploadSelected').removeAttribute('disabled');
    flock_updatePhotoOptionFields();
  } else {
    $('bcasterServiceUploadSelected').setAttribute('disabled', true);
  }
}

function flock_updatePhotoOptionFields() {
  flock_setupPhotoPropsUIFields(gSelectedApi);
}

function flock_launchSingleUpload() {
  // var service = gPhotoMgrSvc.getDefaultService();
  var service = $('servicesMenuList').selectedItem.svc;
  gSelectedApi = service;

  var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
  var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
  var stringBundle = stringBundleService.createBundle("chrome://flock/locale/photo/photo.properties", localeService.getApplicationLocale());

  if (!service.getAuthenticatedAccount()) {
    var loginListener = {
      onSuccess: function(aSubject, aTopic) {
        if (service.getAuthenticatedAccount()) {
          flock_launchUploadOptions();
        }
      },
      onError: function(aError) { }
    };

    var accountURN = $("servicesMenuList").value;
    var account = service.getAccount(accountURN);
    account.login(loginListener);
  } else {
    flock_launchUploadOptions();
  }
}

function flock_launchUploadOptions() {
//  var params = {};
  var photoUploads = Array();

  photoUploads.push(window.arguments[0].aPhoto);
//  params.photoUploads = photoUploads;
//  params.aPhoto = window.arguments[0].aPhoto;
//  params.aTarget = gTarget;
//  params.numUploads = 1;

  var acUtils = Components.classes["@flock.com/account-utils;1"]
                          .getService(Components.interfaces.flockIAccountUtils);

  var params = {
    serviceId: acUtils.getServiceIDForAccountURN($('servicesMenuList').selectedItem.value),
    accountURN: $('servicesMenuList').selectedItem.value,
    photoUploads: photoUploads
  };
  DEBUG("doUpload(): Get the photos");

  var rv = window.openDialog("chrome://browser/content/flock/photo/flockPhotoUploadOptions.xul", "_blank", "modal,centerscreen", params);
  if (rv && params.launchUploader == true) {
    gPhoto.album = params.albumId;
    photoProperties.synch();
    flock_doSingleUpload();
    return true;
  } else {
    return false;
  }
}

function flock_doSingleUpload() {
  var rval = {};
  // var api = gPhotoMgrSvc.getDefaultService();
  var api = gSelectedApi;
  window.openDialog("chrome://browser/content/flock/photo/uploadingSinglePhoto.xul", "UploadingSinglePhoto", "modal, centerscreen", api, gPhoto, rval);
  var photo = rval.photo;
  var html = photo.buildHTML(); 

  // TODO - the html should be inserted where the mouse cursor was when the drop occurred 
  // not just at the end

  if (gTarget.tagName == "editor") {
    gTarget.contentWindow.document.body.innerHTML = gTarget.contentWindow.document.body.innerHTML + html;
  }
  else {
    gTarget.value = gTarget.value + html;
  }
  window.close();
  window.blur();
  return;
}

var accountListener = {
  onStart: function(aSubject, aTopic) {
    $("cmd_doUpload").setAttribute("disabled", true);
  },
  onSuccess: function (aSubject, aTopic) {
    var acct = aSubject.QueryInterface(Ci.flockIWebServiceAccount);
    var urn = acct.urn;
    dump("Try to match "+urn+"\n");
    // Select the menu list item representing the account that was just
    // authenticated...
    var items = $('servicesMenuList').firstChild.childNodes;
    for (var i = 0; i < items.length; i++) {
      var item = items.item(i);
      dump(item.value+"?\n");
      if (item.value == urn) {
        $('servicesMenuList').selectedIndex = i;
        break;
      }
    }
    
    $("cmd_doUpload").removeAttribute("disabled");
    
  },
  onError: function (aSubject, aTopic, aError) {
    DEBUG("accountListener: onError('"+aTopic+"')");
    flock_photo.util.populateServicesPopup($('servicesMenuList').firstChild, this);
    $("cmd_doUpload").removeAttribute("disabled");
  }
};
