/*
 * BEGIN FLOCK GPL
 *
 * Copyright Flock Inc. 2005-2008
 * http://flock.com
 *
 * This file may be used under the terms of the
 * GNU General Public License Version 2 or later (the "GPL"),
 * http://www.gnu.org/licenses/gpl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * END FLOCK GPL
 */

#include "flockAsyncImageScaler.h"
#include "flockAsyncImageScalerThread.h"


#include "nsCOMPtr.h"

#include "nsIProxyObjectManager.h"
#include "nsServiceManagerUtils.h"

#include <stdio.h>

static NS_DEFINE_CID(kProxyObjectManagerCID, NS_PROXYEVENT_MANAGER_CID);

NS_IMPL_ISUPPORTS1(flockAsyncImageScaler, flockIAsyncImageScaler)

flockAsyncImageScaler::flockAsyncImageScaler()
{
	mThread = new flockAsyncImageScalerThread();
	mThread->Init();
	mThread->GetProxy(getter_AddRefs(mProxy));
}

flockAsyncImageScaler::~flockAsyncImageScaler()
{
    /* destructor code */
}

NS_IMETHODIMP flockAsyncImageScaler::DoAsyncMagick(nsIArray* aParamArray, flockIAsyncImageScalerListener *aListener)
{
   	nsresult rv = NS_OK;
	// get the proxy manager
	nsCOMPtr<nsIProxyObjectManager> pmgr =
		do_GetService(kProxyObjectManagerCID, &rv);
	if (NS_FAILED(rv)) {
		return rv;
	}

	flockIAsyncImageScalerListener* listener_proxy = 0;
	rv = pmgr->GetProxyForObject (NS_UI_THREAD_EVENTQ, 
			NS_GET_IID (flockIAsyncImageScalerListener), aListener,
			PROXY_SYNC|PROXY_ALWAYS, (void**)&listener_proxy);
	if (NS_FAILED(rv)) {
		return rv;
	}
	
	PRUint32 length;
    aParamArray->GetLength(&length);
	
    printf("ImageScaler: %d\n", length);

    return mProxy->DoAsyncMagick(aParamArray, listener_proxy);
}
