// vim: ts=4 sw=4
/*
 * BEGIN FLOCK GPL
 *
 * Copyright Flock Inc. 2005-2008
 * http://flock.com
 *
 * This file may be used under the terms of the
 * GNU General Public License Version 2 or later (the "GPL"),
 * http://www.gnu.org/licenses/gpl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * END FLOCK GPL
 */

#ifndef __flockAsyncImageScalerThread_h__
#define __flockAsyncImageScalerThread_h__

#include "nsCOMPtr.h"

#include "nsISupports.h"
#include "nsIRunnable.h"
#include "nsIThread.h"
#include "nsIEventQueue.h"

#include "prmon.h"


#include "flockIAsyncImageScaler.h"

class flockAsyncImageScalerThread : public nsIRunnable {
public:
    flockAsyncImageScalerThread();
    virtual ~flockAsyncImageScalerThread();

    NS_DECL_ISUPPORTS
    NS_DECL_NSIRUNNABLE

	nsresult Init();
    nsresult GetProxy(flockIAsyncImageScaler **aProxy);

private:
    nsCOMPtr<nsIThread> mThread;

    nsCOMPtr<nsIEventQueue> mEventQueue;

	nsCOMPtr<flockIAsyncImageScaler> mProxy;

    PRLock *mLock;
    PRMonitor *mMonitor;

    bool mRunning;
};



#endif
