//
// BEGIN FLOCK GPL
//
// Copyright Flock Inc. 2005-2008
// http://flock.com
//
// This file may be used under the terms of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// END FLOCK GPL
//

#include "flockImageScalerImpl.h"
#include "nsString.h"
#include "nsIProcess.h"
//#include "Epeg.h"
#include "nsAppDirectoryServiceDefs.h"

#if defined(XP_WIN)
# include <direct.h>
# include <process.h>
#else
# include <unistd.h>
#endif

NS_IMPL_ISUPPORTS1(flockImageScalerImpl, flockIImageScaler)

//static NS_DEFINE_CID(kStringInputStream, NS_STRINGINPUTSTREAM_CID);

flockImageScalerImpl::flockImageScalerImpl()
{
  /* member initializers and constructor code */
}

flockImageScalerImpl::~flockImageScalerImpl()
{
  /* destructor code */
}

NS_IMETHODIMP flockImageScalerImpl::Resize(const nsACString & aInputFileName, const nsACString & aOutputFileName, PRInt32 aWidth, PRInt32 aHeight, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

NS_IMETHODIMP flockImageScalerImpl::Rotate(const nsACString & aInputFileName, const nsACString & aOutputFileName, PRInt32 aDegrees, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

NS_IMETHODIMP flockImageScalerImpl::GetDimensions(const nsACString & aInputFileName, PRInt32 *aWidth, PRInt32 *aHeight, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

NS_IMETHODIMP flockImageScalerImpl::DoMagick(const char** aParams , PRUint32 aCount, PRBool *_retval)
{
    nsresult rv;
    nsCOMPtr<nsIProcess> proc(do_CreateInstance("@mozilla.org/process/util;1", &rv));
    if(NS_FAILED(rv)) return rv;

    nsCOMPtr<nsIFile> gmExec;
    nsCOMPtr<nsIFile> flockImageTmpDir;
    
    NS_GetSpecialDirectory("CurProcD", getter_AddRefs(gmExec));
    NS_GetSpecialDirectory("ProfD", getter_AddRefs(flockImageTmpDir));

    nsCAutoString nativePath;
    nsCAutoString tmpDirNativePath;
    
    gmExec->GetNativePath(nativePath);
    flockImageTmpDir->GetNativePath(tmpDirNativePath);
#if defined(XP_WIN)
    //_chdir(nativePath.get());
    _chdir(tmpDirNativePath.get());
    gmExec->Append(NS_LITERAL_STRING("gm.exe"));
    //_chdir(tmpDirNativePath.get());
#else
    chdir(tmpDirNativePath.get());
    gmExec->Append(NS_LITERAL_STRING("gm"));
#endif
    PRBool gmExists = PR_FALSE;
    rv = gmExec->Exists(&gmExists);
    if(NS_FAILED(rv)) return rv;
    if(!gmExists) return -1;
    rv = proc->Init(gmExec);
    if(NS_FAILED(rv)) return rv;
    PRUint32 exitCode;
    return proc->Run(/*blocking*/PR_TRUE, aParams, aCount, &exitCode);
}
