// BEGIN FLOCK GPL
//
// Copyright Flock Inc. 2005-2008
// http://flock.com
//
// This file may be used under the terms of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// END FLOCK GPL

const FOLDERICON = "chrome://global/skin/tree/folder.png";

var gShelf;
var gShelfContext;

function createNotesFolder(aFolder) {
  var thumbnail = FOLDERICON;
  var title = aFolder.name;
  var folderUrn = aFolder.id();
 
  var item = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "media");
  item.setAttribute('type', 'person'); // Ok, this is not a person but it works anyway
  item.setAttribute('thumbnail', thumbnail);
  item.setAttribute('title', title);
  item.setAttribute('tooltiptext', title);
  item.setAttribute('url', folderUrn);
  item.setAttribute('onclick', 'goToFolder(this.url)');

  var slidey = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "slideyitem");
  slidey.appendChild(item);

  return slidey;
}

var gShelfCommandController = new CommandController();

var faves = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-favorites'].getService(Components.interfaces.flockIFavoritesService);
faves.QueryInterface(Components.interfaces.nsIRDFDataSource);

// should always work
gShelfCommandController.cmd_shelfAddNote = function () {
  var newId = SHELF_SRV.insert("Untitled", "", "", "", -1);
  var params = {
    objectid : newId
  };
  window.openDialog("chrome://flock/content/blog/editor.xul",
                    "_blank",
                    "chrome,close,titlebar,resizable=yes,toolbar=no,dialog=no,scrollbars=yes,centerscreen",
                    params);
};
    
    // ignore if there is nothing there
gShelfCommandController.cmd_shelfClear = function () {
  gShelfItemCommandController.detachFrom()
  SHELF_SRV.clear();
        
  gShelf.scrollHome();
};


// we do not get to focus the main slidey box, so we are
// going to make the controller follow focus
var gShelfItemCommandController = new CommandController();

    // some base stuff
gShelfItemCommandController.cmd_copy = function () {
  flock.command('cmd_shelfItemCopyHTML');
};

gShelfItemCommandController.cmd_delete = function () {
  flock.command('cmd_shelfItemDelete');
};

gShelfItemCommandController.cmd_handleBackspace = function () {
  flock.command('cmd_shelfItemDelete');
};

gShelfItemCommandController.cmd_selectAll = function () {
  flock.command('cmd_shelfItemSelectAll');
};
  // XXX andy: leaving these for erwan to implement,
  //           just stubs to get to the right menu items
  //cmd_paste: function () {
  //    flock.command('cmd_shelfItemPaste');
  //},
  //cmd_cut: function () {
  //    flock.command('cmd_shelfItemCut');
  //},
  
 // XXX andy: I think these two should create proper transfer items
 //           and populate them fully
gShelfItemCommandController.cmd_shelfItemCopyHTML = function () {
  var selected = gShelf.getSelection();
  var srcs = [];
  selected.forEach(function (aVal) {
    srcs.push(aVal.firstChild.src);
  });
  gClipboardHelper.copyString(srcs.join("\n"));
};

gShelfItemCommandController.cmd_shelfItemCopyLink = function () {
  var selected = gShelf.getSelection();
  var urls = [];
  selected.forEach(function (aVal) {
    urls.push(aVal.firstChild.url);
  });
  gClipboardHelper.copyString(urls.join("\n"));
};

gShelfItemCommandController.cmd_shelfItemDelete = function () {
  this.detachFrom(this._attached);
  var aSelection = gShelf.getSelection();
        
  for(var i = 0; i < aSelection.length; ++i) {
    var child = aSelection[i];
    SHELF_SRV.remove(child.id);
  }
  if (!gShelf.canScrollRight) gShelf.scrollEnd();
};

gShelfItemCommandController.cmd_shelfItemSelectAll = function () {
  gShelf.selectAll();
};
        
gShelfItemCommandController.cmd_shelfItemEdit = function () {
  var theObject = gShelf.getSelection()[0];

  var params = {
    objectid : theObject.id
  };
  window.openDialog("chrome://flock/content/blog/editor.xul",
                    "_blank",
                    "chrome,close,titlebar,resizable=yes,toolbar=no,dialog=no,scrollbars=yes,centerscreen",
                    params);
};

gShelfItemCommandController.cmd_shelfItemOpen = function () {
  var item = gShelf.getSelection()[0].firstChild;
  flock.command('cmd_itemOpen', item.url);
};

gShelfItemCommandController.cmd_shelfItemOpenInTab = function () {
  var item = gShelf.getSelection()[0].firstChild;
  flock.command('cmd_itemOpen', item.url, 'tab');
};

gShelfItemCommandController.cmd_shelfBlogThis = function () {
  var item = gShelf.getSelection()[0].firstChild;
  var params = {
    file : 0,
    content : item.src + "<p></p>"
  };
  flock_blogDoOpenPost(EDITOR_URL, params);
};

gShelfItemCommandController.cmd_shelfImageSendToUploader = function () {
  var item = gShelf.getSelection()[0].firstChild;
  var photoUrls = new Array(); 
  photoUrls[0] = item.url;
  var dropProcessor = new PhotoDropProcessor(photoUrls, null);
  dropProcessor.start();        
};

gShelfItemCommandController.cmd_shelfItemOpenInWindow = function () {
  var item = gShelf.getSelection()[0].firstChild;
  flock.command('cmd_itemOpen', item.url, 'window');
};

gShelfItemCommandController.cmd_shelfItemOpenInTabs = function () {
  var selected = gShelf.getSelection();
  selected.forEach(function (aVal) {
    flock.command('cmd_itemOpen', aVal.firstChild.url, 'tab');
  });
};

// util for our hopping behavior
gShelfItemCommandController.attachTo = function (aNode) {
  // XXX andy: this feels mildly unreliable, I feel like I have hit
  //           most of the edge cases, but it still makes me uneasy
  if (this._attached) {
    this.detachFrom(this._attached);
    //throw "already attached";
    //return;
  }
  aNode.controllers.appendController(this);
  this.updateCommands();
  this._attached = aNode;
};

gShelfItemCommandController.detachFrom = function (aNode) {
  if (!this._attached) {
    //throw "not attached";
    return;
  }
  if (!aNode) this._attached.controllers.removeController(this);
  try {
    aNode.controllers.removeController(this);
  } catch(e) {}
  this._attached = null;
};

gShelfItemCommandController.updateCommands = function () {
  // dispatch a focus event so that the menus on top will update
  document.commandDispatcher.updateCommands('select');
  this.updateNoteNotSelected();
};

gShelfItemCommandController.updateNoteNotSelected = function () {
  var selected = gShelf.getSelection();
  var noteNotSelected = selected.every(function (aVal) {
    if (aVal.firstChild.type == "note") return false;
    return true;
  });
  if (noteNotSelected) {
    $('bcast_shelfNoteNotSelected').setAttribute('disabled', 'false');
  }
  else {
    $('bcast_shelfNoteNotSelected').setAttribute('disabled', 'true');
  }
};

    // drag checks
gShelfItemCommandController.onDragDrop = function (aEvt) {
  this.detachFrom(this._attached);
};

gShelfItemCommandController.onDragStart = function (aEvt) {
  this.detachFrom(this._attached);
};


function onLoad_shelf(aEvt) {
  XXX('onLoad_shelf');

  // Main controller
  // gShelf = new flock.xul.ShelfController($('shelfContainer'), {
  gShelf = new flock_shelf.controller($('shelfContainer'), $('webclip-panel'),
    $('flock-createSnippet-button'), $('flock-clearSnippets-button'),
    $('webclip-deck'), $('icon-view'));

  // gShelf.refreshPanel();
    
  // RDF Updater
/*  window.gShelfRDFObserver = {
    onAssert            : function(ds, source, predicate, target) { 
      gShelf.refreshPanel();
    },
    onUnassert          : function(ds, source, predicate, target){
      gShelf.refreshPanel();
    },
    onChange            : function(ds, source, predicate, oldTarget, newTarget){
      gShelf.refreshPanel();
    },
    onMove              : function(ds, oldSource, newSource, predicate, target){},
    onBeginUpdateBatch  : function(ds){},
    onEndUpdateBatch    : function(ds){}
  };
  faves.AddObserver(window.gShelfRDFObserver);*/
    
  // Commands   
  window.controllers.appendController(gShelfCommandController);
    
  // Context Menu
  gShelfContext = {
    mNode: $('shelfContext'),
    popupSet: "shelfContextPopupSet",
    switchTo: function (aPopup) {
      while (this.mNode.hasChildNodes()){
        this.mNode.removeChild(this.mNode.firstChild);
      }
      var clonedNode = $(aPopup).cloneNode(true);

      while(clonedNode.hasChildNodes()){
        this.mNode.appendChild(clonedNode.firstChild);
      }
    },
    onPopupShowing: function (aEvt) {
      var count = gShelf.getSelection().length;
      if (count == 0) {
                this.switchTo("shelfEmptyContext");
            }
            else if (count == 1) {
                this.switchTo("shelfSingleContext");
            }
            else {
                this.switchTo("shelfMultipleContext");
            }
            return true;
        }
    };

    // XXX andy: hack to get around faulty slideybox keystroke handling
    $('webclip-deck').addEventListener('keydown', gShelf.preventSlideyboxKeystrokesHack, true);

  makeBread(faves_coop.get("urn:flock:snippets"));
}

function onUnload_shelf(aEvt) {
    XXX('onUnload_shelf');
    // faves.RemoveObserver(window.gShelfRDFObserver);
}

function onShelfItemDlbclick(shelfIcon){
  goDoCommand('cmd_shelfItemEdit');
}

function goToFolder(aFolderId){
  dump("Building for "+aFolderId+"\n");
  var slidey = $("icon-view");
  var sources = slidey.database.GetDataSources();
  while (sources.hasMoreElements())
    slidey.database.RemoveDataSource(sources.getNext());
  slidey.database.AddDataSource(faves);
  if (aFolderId == "")
    slidey.ref = "urn:flock:snippets";
  else
    slidey.ref = aFolderId;
  slidey.builder.rebuild();
  makeBread(faves_coop.get(slidey.ref));
}

makeBread = function(aFolder) {
  var breadbox = $('shelf-breadcrumbs')
  while (breadbox.hasChildNodes())
    breadbox.removeChild(breadbox.firstChild);
  var folder = aFolder;
  while (folder) {
    var label = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "label");
    if (folder.id() == "urn:flock:snippets") {
      label.setAttribute('value', breadbox.getAttribute('allLabel'));
      label.setAttribute('onclick', 'goToFolder("");');
    }
    else {
      label.setAttribute('value', folder.name);
      label.setAttribute('onclick', 'goToFolder("'+folder.id()+'");');
    }
    label.setAttribute('class', 'breadcrumb');
    breadbox.insertBefore(makeArrow(), breadbox.firstChild);
    breadbox.insertBefore(label, breadbox.firstChild);

    folder = folder.getParent();
  }
}



window.addEventListener('load', onLoad_shelf, false);
window.addEventListener('unload', onUnload_shelf, false);
