// BEGIN FLOCK GPL
//
// Copyright Flock Inc. 2005-2008
// http://flock.com
//
// This file may be used under the terms of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// END FLOCK GPL

var pref_service = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var location_pref = "flock.minibar.location";
var open_pref = "flock.minibar.open";
var id_pref  = "flock.minibar.objId";
var curr_location = null;
function $T(aID) {
	return $("topbarBrowser").contentDocument.getElementById(aID);
}

function TopbarJSCtx() {
  return $$("topbarBrowser").contentWindow;
}

function flock_TopbarHideExtensionArea() {
    // show the main Extension UI
    $("flock_TopbarUIExtensionArea").removeAttribute("collapsed");
    // Collapse extension areas
    var extArea = $("flock_TopbarUIExtensionArea");
    for (var i=0; i<extArea.childNodes.length; ++i) {
        extArea.childNodes.item(i).setAttribute("hidden", true);
    }
}

function flock_ToolbarHideTopbarboxArea() {
   var extArea = $("topbarBox");
    for(var i=0;i<extArea.childNodes.length;++i) {
        extArea.childNodes.item(i).setAttribute("hidden", true);
    }
}

function flock_topbarSize(height) {
  $('topbarBox').setAttribute("height", height);
}

function flock_topbarHide() {
  // modify this function so that it will clear the 
  // current "topbar" attribute
  // that we use in topbarOverlay.js

  var topbars = $('flock_TopbarBroadcasterSet').childNodes;
  for (i = 0; i < topbars.length; ++i) {
      var item = topbars[i];
      if (item.getAttribute('checked')) {
          item.removeAttribute('checked');   
      }
  }

  $('topbar').setAttribute("hidden", true);
  $('topbarBrowser').setAttribute("src", "");
  pref_service.setBoolPref(open_pref,false);
}

function flock_topbarMove(ignoreLocation) {
  // modify this function so that it will set the location attribute
  // that we use in topbarOverlay.js to know where to put it on startup
  var location = null;
  try{
    location = pref_service.getCharPref(location_pref);
  }catch(e)
  {
    
  }
  if(ignoreLocation)
  {
    curr_location = null; // we don't want to move just open where it was last
  }
  if (location == null || location == 'top' &&  curr_location != 'top') {
    $('appcontent').removeAttribute('dir');
    pref_service.setCharPref(location_pref,"top");
    curr_location = 'top';
  }else if (location == 'bottom' &&  curr_location == 'bottom') {
      $('appcontent').removeAttribute('dir');
      pref_service.setCharPref(location_pref,"top");
      curr_location = 'top';
  }else {
    $('appcontent').setAttribute('dir', 'reverse');
    pref_service.setCharPref(location_pref,"bottom");
    curr_location = 'bottom';
  }
   return  curr_location;
}

function flock_loadTopbar() {
  try {
    if (pref_service.getBoolPref(open_pref)) {
      flock_topbarSelectById(pref_service.getCharPref(id_pref));
    }
  } catch(e) { /* top bar is closed by default; */ }
}

function flock_topbarSelectById(aID, aStayOpen ) {
  pref_service.setCharPref(id_pref,aID);
  pref_service.setBoolPref(open_pref,true);
  flock_topbarSelect($(aID), aStayOpen);
}

function flock_topbarSelect(aObj, aStayOpen) {
    // modify this function so that it will set the attribute
    // that we use in topbarOverlay.js
    var topbarBrowser = $("topbarBrowser");
    if (aObj.getAttribute("checked")) {
        if (aStayOpen) return;
        try {
            if (topbarBrowser.contentWindow.onunload) {
                topbarBrowser.contentWindow.onunload();
            }
            if (topbarBrowser.contentWindow.topbarUnload) {
                    topbarBrowser.contentWindow.topbarUnload();
            }
        } catch(e) {}
        $('topbar').setAttribute("hidden", true);
        topbarBrowser.setAttribute("src", "");
        aObj.removeAttribute("checked");
        //we are closing so set the pref to close so when browser launches again it knows
        pref_service.setBoolPref(open_pref,false);
        return;
    }
    var topbars = $('flock_TopbarBroadcasterSet').childNodes;
    for (i = 0; i < topbars.length; ++i) {
        var item = topbars[i];
        if (item.getAttribute('checked')) {
            item.removeAttribute('checked');   
        }
    }
    flock_TopbarHideExtensionArea();

    // Setup extension area
    var extID = aObj.getAttribute("extID")
    if(extID) {
        if($(extID)) {
            $(extID).removeAttribute("hidden");
        }
        else {
            alert("Error! You havn't properly specified extID in your topbar");
        }
    }
    
    var url = aObj.getAttribute("url")
    if (url) {
        if (url != topbarBrowser.getAttribute("src")) {
            var height = aObj.getAttribute("topbarHeight");
            if(height) {
                $('topbarBox').setAttribute("height", height);
            }
            $('topbar').removeAttribute("hidden");
            $('topbarBrowser').removeAttribute("hidden"); // XXX - not sure why we have to do this since we didn't in cardinal - ja
            topbarBrowser.setAttribute("src", url);
        } 
        aObj.setAttribute("checked","true");
    } 
    else {
        $('topbar').setAttribute("hidden", true);
        topbarBrowser.setAttribute("src", "");
    }
    
    var onselect = aObj.getAttribute("onselect")
    if(onselect) {
        eval(onselect);
    }
    var value = aObj.getAttribute("value");
    flock_topbarMove(true);
}
