   !include "MUI.nsh"
   !include "LogicLib.nsh"

   ReserveFile "${NSISDIR}\Plugins\InstallOptions.dll"
   ReserveFile "SetBrowser.ini"
   
   !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
  
   ; General

   Name "Browser Set Tool"                          ; name on welcome and finish pages
   OutFile "SetBrowser.EXE"                ; name of resulting installer
   Caption "Browser Set Tool"
   WindowIcon off
   InstProgressFlags smooth
   AddBrandingImage left 100
   BrandingText /TRIMRIGHT "Flock Browser Set Tool"
   InstallButtonText "Set Default"

   !define LOGO_IMAGE "flock.ico"
   !define MUI_ABORTWARNING
   !define MUI_ICON ".\flock.ico"                 ; MUI_ICON and MUI_UNICON must be
   !define MUI_UNICON ".\flock.ico"               ; exactly the same size.
   !define LANG_ENGLISH "1033"
   !define SPI_SETNONCLIENTMETRICS                0x002A

   VAR FIREFOX
   VAR RUNCMD_FIREFOX   ; Status Var 1
   VAR VERSION_FIREFOX
   VAR MOZILLA
   VAR RUNCMD_MOZILLA   ; Status Var 2
   VAR VERSION_MOZILLA
   VAR STATUS
   VAR BRTEMP
  
   Page custom SetCustom CreatePrefs ""
   !insertmacro MUI_PAGE_INSTFILES

   !insertmacro MUI_LANGUAGE "English"

Section "Main Section" Main
   SetAutoClose True
   
   ${SELECT} $STATUS 
    ${CASE} "0"
    ; IE
    Exec '"$SYSDIR\shmgrate.exe" OCInstallReinstallIE'
    Exec '"$SYSDIR\shmgrate.exe" OCInstallShowIE'
    ${CASE} "1"
    ; FF
    Exec "$RunCMD_FIREFOX"
    ${CASE} "2"
    ; MOZ
    Exec "$RUNCMD_MOZILLA"
   ${EndSelect}
   
   ReadRegStr $R3 HKCU "Control Panel\Desktop\WindowMetrics" "Shell Icon Size"
   IntOp $R4 $R3 - 1
   WriteRegStr HKCU "Control Panel\Desktop\WindowMetrics" "Shell Icon Size" $R4
   SendMessage ${HWND_BROADCAST} ${WM_SETTINGCHANGE} 0 "Software\Clients\StartMenuInternet" $R0
   WriteRegStr HKCU "Control Panel\Desktop\WindowMetrics" "Shell Icon Size" $R3
   SendMessage ${HWND_BROADCAST} ${WM_SETTINGCHANGE} ${SPI_SETNONCLIENTMETRICS} 0 $R1
SectionEnd
  

Function SetCustom

  !insertmacro MUI_HEADER_TEXT "Set Default Browser" "Please choose a default browser from the list below."
  ;Display the InstallOptions dialog
  InstallOptions::dialog "$PLUGINSDIR\SetBrowser.ini"
FunctionEnd

Function CreatePrefs

  ReadINIStr $BRTEMP "$PLUGINSDIR\SetBrowser.ini" "Field 3" "State"
  StrCmp $BRTEMP "1" +1 +3
  StrCpy $STATUS 0
  GOTO Found_Browser
  ReadINIStr $BRTEMP "$PLUGINSDIR\SetBrowser.ini" "Field 4" "State"
  StrCmp $BRTEMP "1" +1 +3
  StrCpy $STATUS 1
  GOTO Found_Browser
  ReadINIStr $BRTEMP "$PLUGINSDIR\SetBrowser.ini" "Field 5" "State"
  StrCmp $BRTEMP "1" +1 +3
  StrCpy $STATUS 2
  GOTO Found_Browser
  STRCPY $STATUS "0"
  Found_Browser:
  ;MessageBox MB_OK "$STATUS"
FunctionEnd

Function .OnInit
   InitPluginsDir
   !insertmacro MUI_INSTALLOPTIONS_EXTRACT "SetBrowser.ini"
   File "/oname=$PLUGINSDIR\SetBrowser.ini" "SetBrowser.ini"
   StrCPY $STATUS "0" ; Set Internet Explorer as Default Browser (In case none other are detected)
   WriteINIStr "$PLUGINSDIR\SetBrowser.ini" "Field 3" "State" "1"
   WriteINIStr "$PLUGINSDIR\SetBrowser.ini" "Field 4" "State" "0"
   WriteINIStr "$PLUGINSDIR\SetBrowser.ini" "Field 5" "State" "0"

   ReadRegstr $RUNCMD_FIREFOX HKLM "SOFTWARE\Clients\StartMenuInternet\FIREFOX.EXE\InstallInfo" "ReinstallCommand"
   StrLen $0 $RUNCMD_FIREFOX
   ${IF} $0 >= "5" 
    STRCPY $FIREFOX "1"
    ReadRegstr $VERSION_FIREFOX HKLM "SOFTWARE\Mozilla\Mozilla Firefox" "Currentversion"
    WriteINIStr "$PLUGINSDIR\SetBrowser.ini" "Field 4" "Flags" "0"
   ${ELSE}
    STRCPY $FIREFOX "0"
    WriteINIStr "$PLUGINSDIR\SetBrowser.ini" "Field 4" "Flags" "Disabled"
   ${ENDIF}
   ;messagebox MB_OK "$RUNCMD_FIREFOX | $VERSION_FIREFOX"

   StrCPY $STATUS "0"
   ReadRegstr $RUNCMD_MOZILLA HKLM "SOFTWARE\Clients\StartMenuInternet\MOZILLA.EXE\InstallInfo" "ReinstallCommand"
   StrLen $0 $RUNCMD_MOZILLA
   ${IF} $0 >= "5"
    STRCPY $MOZILLA "1"
    ReadRegstr $VERSION_MOZILLA HKLM "SOFTWARE\Mozilla\Mozilla" "Currentversion"
    WriteINIStr "$PLUGINSDIR\SetBrowser.ini" "Field 5" "Flags" "0"
   ${ELSE}
    STRCPY $MOZILLA "0"
    WriteINIStr "$PLUGINSDIR\SetBrowser.ini" "Field 5" "Flags" "Disabled"
   ${ENDIF}
   ;messagebox MB_OK "$RUNCMD_MOZILLA | $VERSION_MOZILLA"

FunctionEnd

