;
; BEGIN FLOCK MPL
;
; Version: MPL 1.1/GPL 2.0/LGPL 2.1
;
; The contents of this file are subject to the Mozilla Public License Version
; 1.1 (the "License"); you may not use this file except in compliance with
; the License. You may obtain a copy of the License at
; http://www.mozilla.org/MPL/
;
; Software distributed under the License is distributed on an "AS IS" basis,
; WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
; for the specific language governing rights and limitations under the
; License.
;
; The Original Code is Flock Browser code.
;
; The Initial Developer of the Original Code is
; Flock Inc.
; Portions created by the Initial Developer are Copyright (C) 2005-2008
; the Initial Developer. All Rights Reserved.
;
; Contributor(s):
;
; Alternatively, the contents of this file may be used under the terms of
; either of the GNU General Public License Version 2 or later (the "GPL"),
; or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
; in which case the provisions of the GPL or the LGPL are applicable instead
; of those above. If you wish to allow use of your version of this file only
; under the terms of either the GPL or the LGPL, and not to allow others to
; use your version of this file under the terms of the MPL, indicate your
; decision by deleting the provisions above and replace them with the notice
; and other provisions required by the GPL or the LGPL. If you do not delete
; the provisions above, a recipient may use your version of this file under
; the terms of any one of the MPL, the GPL or the LGPL.
;
; END FLOCK MPL
;

Function SetCustom
    ;Display the InstallOptions dialog
    !insertmacro MUI_HEADER_TEXT_PAGE "Configure your Browser" "Configure your Browser by modifying the options below."
    Push ${TEMP1}
    InstallOptions::dialog "$PLUGINSDIR\config.ini"
    Pop ${TEMP1}
FunctionEnd

Function CreatePrefs

    ReadINIStr $DT_ICON "$PLUGINSDIR\config.ini" "Field 4" "State"  ; Full Manual Mode
    ReadINIStr $QL_ICON "$PLUGINSDIR\config.ini" "Field 5" "State"  ; Full Manual Mode
    ReadINIStr $ANONSTAT "$PLUGINSDIR\config.ini" "Field 6" "State" ; Full Manual Mode
FunctionEnd

Function appCheck
  Exch $1
  Push $0
  Var /GLOBAL appCheckStartupMsg
  Var /GLOBAL CheckRunningMsg
  Var /GLOBAL ErrorPrefix
  Var /GLOBAL ErrorNoSearchMsg
  Var /GLOBAL ErrorNoSystemMsg
  Var /GLOBAL ErrorUnsupportedMsg
  Var /GLOBAL ErrorInvalidnameMsg
  Var /GLOBAL ErrorUnknownMsg
  StrCpy $appCheckStartupMsg "Looking to see if ${PRODUCT_NAME} is running. with application name:"
  StrCpy $CheckRunningMsg "${PRODUCT_NAME} is currently running.  You must exit ${PRODUCT_NAME} before continuing with the install.$\nAfter you have exited ${PRODUCT_NAME}, click OK to begin the installation."
  StrCpy $ErrorPrefix "When search for the program ${PRODUCT_NAME} this installer recieved an error"
  StrCpy $ErrorNoSearchMsg "$ErrorPrefix, that the installer could search for the program."
  StrCpy $ErrorNoSystemMsg "$ErrorPrefix, that the installer was unable to idenify the system type."
  StrCpy $ErrorUnsupportedMsg "$ErrorPrefix, that this OS is unsupported by this installer."
  StrCpy $ErrorInvalidnameMsg "$ErrorPrefix, that program name was invalid."
  StrCpy $ErrorUnknownMsg "$ErrorPrefix with an unknown error code of: "
  appCheckMain:
    ;For looking up application by Windows class name
    ;FindWindow $0 $1        ; FindWindow output=$0 class="$1" text="" hwndparent="" hwndafter=""
    ;IntCmp $0 0 done

    ;; DEBUG ONlY ; MessageBox MB_OK "$appCheckStartupMsg ${APP_NAME}"
    IntOp $R0 1 + 1          ; initialize R0 b4 calling FindProc
    FindProcDLL::FindProc "${APP_NAME}"
    IntCmp $R0 1 checkmsg1 appCheckDone appCheckError
    checkmsg1:
      MessageBox MB_OKCANCEL "$CheckRunningMsg" IDCANCEL appCheckCancel IDOK 0
      ; SendMessage $0 ${WM_DESTROY} 0 0
      ; SendMessage $0 ${WM_CLOSE} 0 0
      ; Removed the kill because Session saver complains.
      ; KillProcDll::KillProc "${APP_NAME}"
      Sleep 750
      Goto appCheckMain
  appCheckError:
      IntCmp $R0 605 appCheckErrorNoSearch 0 0
      IntCmp $R0 606 appCheckErrorNoSystem 0 0
      IntCmp $R0 607 appCheckErrorUnsupported 0 0
      IntCmp $R0 632 appCheckErrorInvalidname 0 0
      Goto appCheckErrorUnknown
  appCheckErrorNoSearch:
     MessageBox MB_OK $ErrorNoSearchMsg
  appCheckErrorNoSystem:
     MessageBox MB_OK $ErrorNoSystemMsg
  appCheckErrorUnsupported:
     MessageBox MB_OK $ErrorUnsupportedMsg
  appCheckErrorInvalidname:
     MessageBox MB_OK $ErrorInvalidnameMsg
  appCheckErrorUnknown:
     MessageBox MB_OK "$ErrorUnknownMsg $R0"
  appCheckCancel:
      Abort
  appCheckDone:
      ;; DEBUG only ; MessageBox MB_OK "No app named ${APP_NAME} found. returned: $R0"
      Pop $0
      Pop $1
FunctionEnd

Function un.appCheck
     Exch $1
     Push $0
    loop3:
     IntOp $R0 0 + 0          ; initialize R0 b4 calling FindProc
     FindProcDLL::FindProc ${APP_NAME}
     IntCmp $R0 1 checkmsg2 done3 done3
     checkmsg2:
     MessageBox MB_OKCANCEL "${PRODUCT_NAME} is currently running.  Please close it and then click OK to continue uninstalling." IDCANCEL unappCheckCancel IDOK 0
;    CloseAndUninstall:
;     KillProcDll::KillProc "${APP_NAME}"
     Sleep 750
     Goto loop3
    unappCheckCancel:
     Abort "You chose not to uninstall."
    done3:
     Pop $0
     Pop $1
FunctionEnd
; Called Functions that perform small functions

; Usage:
;   Call IsUserAdmin
;   Pop $R0   ; at this point $R0 is "true" or "false"
;
Function IsUserAdmin
Push $R0
Push $R1
Push $R2

ClearErrors
UserInfo::GetName
IfErrors Win9x
Pop $R1
UserInfo::GetAccountType
Pop $R2

StrCmp $R2 "Admin" User_Admin Continue
User_Admin:
; Observation: I get here when running Win98SE. (Lilla)
; The functions UserInfo.dll looks for are there on Win98 too,
; but just don't work. So UserInfo.dll, knowing that admin isn't required
; on Win98, returns admin anyway. (per kichik)
; MessageBox MB_OK 'User "$R1" is in the Administrators group'
StrCpy $R0 "true"
StrCpy $NT "1"
Goto UaDone

Continue:
; You should still check for an empty string because the functions
; UserInfo.dll looks for may not be present on Windows 95. (per kichik)
StrCmp $R2 "" Win9x
StrCpy $R0 "false"
StrCpy $NT "0"
;MessageBox MB_OK 'User "$R1" is in the "$R2" group'
Goto UaDone

Win9x:
; comment/message below is by UserInfo.nsi author:
; This one means you don't need to care about admin or
; not admin because Windows 9x doesn't either
;MessageBox MB_OK "Error! This DLL can't run under Windows 9x!"
StrCpy $R0 "true"
StrCpy $NT "0"

UaDone:
;MessageBox MB_OK 'User= "$R1"  AccountType= "$R2"  IsUserAdmin= "$R0"'

Pop $R2
Pop $R1
Exch $R0
FunctionEnd

;--------------------------------------

Function GetSysReqs
  cpudesc::tell
  Pop $0
  IntOp $3 79 + 0                    ; initialize $3 to 79
SkipZero1:
  IntOp $3 $3 + 1                    ; start checking $0 from offset 80
  StrCpy $2 $0 1 $3                  ; is the digit in $2 a zero
  IntCmpU $2 0 SkipZero1 NonZero1 NonZero1
NonZero1:
  StrCpy $2 $0 5 $3                  ; Now get the MHZ value with no leading zeroes
  IntFmt $1 "%u" $2
  ; Minimum CPU is 233MHz
  IntCmpU $1 133 +1 CPUtooslow
  Goto CPUdone
CPUtooslow:
  MessageBox MB_OK "${SYSREQMSG}$\r$\n"
  Abort
CPUdone:
  IntOp $3 89 + 0                     ; initialize $3 to 89
  ; Check RAM
SkipZero2:
  IntOp $3 $3 + 1                     ; start checking $0 from offset 90
  StrCpy $2 $0 1 $3                   ; is the digit in $2 a zero
  ; Skip leading zeroes. RAM is assumed to be a non-zero number, or OS will not work.
  IntCmpU $2 0 SkipZero2 NonZero2 NonZero2
NonZero2:
  StrCpy $2 $0 4 $3                   ; Now get the RAM value with no leading zeroes
  IntFmt $1 "%u" $2
  IntCmpU $1 40 +1 RAMtoosmall
  Goto RAMdone
RAMtoosmall:
  MessageBox MB_OK "${SYSREQMSG}$\r$\n"
  Abort

RAMdone:

FunctionEnd
;----------------------------------------------------------
 ; GetWindowsVersion Function
 ; Usage:
 ;   Call GetWindowsVersion
 ;   Pop $R0
 ;   ; at this point $R0 is "NT 4.0" or whatnot

Function GetWindowsVersion

   Push $R0
   Push $R1

   ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
   IfErrors 0 lbl_winnt

   ; we are not NT
   ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion" VersionNumber
   StrCPY $OS '9X'
   StrCpy $R1 $R0 1
   StrCmp $R1 '4' 0 lbl_error
   StrCpy $R1 $R0 3
   StrCmp $R1 '4.0' lbl_win32_95
   StrCmp $R1 '4.9' lbl_win32_ME lbl_win32_98

   lbl_win32_95:
     StrCpy $R0 '95'
   Goto lbl_done

   lbl_win32_98:
     StrCpy $R0 '98'
   Goto lbl_done

   lbl_win32_ME:
     StrCpy $R0 'ME'
   Goto lbl_done


   lbl_winnt:

   StrCpy $R1 $R0 1
   StrCPY $OS 'NT'
   StrCmp $R1 '3' lbl_winnt_x
   StrCmp $R1 '4' lbl_winnt_x
   StrCpy $R1 $R0 3
   StrCmp $R1 '5.0' lbl_winnt_2000
   StrCmp $R1 '5.1' lbl_winnt_XP
   StrCmp $R1 '5.2' lbl_winnt_2003
   StrCmp $R1 '6.0' lbl_winnt_vista lbl_error

   lbl_winnt_x:
     StrCpy $R0 'NT'
   Goto lbl_done

   lbl_winnt_2000:
     Strcpy $R0 '2000'
     Call IsUserAdmin
     pop $USERADMIN
   Goto lbl_done

   lbl_winnt_XP:
     Strcpy $R0 'XP'
     StrCPY $OS 'XP'
     Call IsUserAdmin
     pop $USERADMIN
   Goto lbl_done

   lbl_winnt_2003:
     Strcpy $R0 '2003'
     StrCPY $OS 'XP'
     Call IsUserAdmin
     pop $USERADMIN
   Goto lbl_done

   lbl_winnt_vista:
     Strcpy $R0 'Vista'
     StrCPY $OS 'VS'
     Call IsUserAdmin
     pop $USERADMIN
   Goto lbl_done

   lbl_error:
     Strcpy $R0 ''
     StrCPY $OS 'XX'
   lbl_done:

   Pop $R1
   Exch $R0

FunctionEnd

;--------------------------------
;Installer Functions

;--------------------------------
; Usage:
; Push "$APPDATA\Mozilla\Firefox\profiles.ini"                     ; Profiles.ini file with full path
; Call FindCurrentFirefoxProfile
; Pop $R1
Function FindCurrentFirefoxProfile
  Exch $R0                        ; Path and filename of the profiles.ini file
  Push $R1                        ; For the profile directory
  Push $R2                        ; For the Temp Profile String "ProfileN"
  Push $R3                        ; For the Default Value
  IntOp $1 0 + 0                  ; initialize $1 to 0
  StrCpy $2 "Profile"             ; For the sections in the profile.ini
  
ProfileReadLoop:
  StrCpy $3 $2$1                   ; Creates ProfileN where N = 0 to well, who knows :)
  IntOp $1 $1 + 1                  ; Increment the Profile Number N for next loop
  ReadIniStr $R1 $R0 $3 "Path"     ; Read in the Path
  IfErrors DoneReadLoop            ; No Path variable so we are done
  ReadIniStr $R3 $R0 $3 "Default"  ; Read in the Default (does not exist if only profile or this is not the default)
  IfErrors ProfileReadLoop         ; If Default does not exist go back to the top of the loop

DoneReadLoop:
  MessageBox MB_OK 'Ini= "$R0" Path= "$R1"  Default= "$R3"  Profile= "$3"'

  Pop $R3                          ; Get rid of temporary stuff (pop back originals)
  Pop $R2
  Pop $R1
  Exch $R0                         ; Will have path of default (or only profile) if any existed
FunctionEnd

;---------------------------------
; Usage:
; Push "string" ; location of extensions.ini
; Push "string" ; GUID of Extension to find
; Pop $R2       ; "true" if extension exists, "false" if not
Function FindFirefoxExtension
  Exch $R0
  Exch $R1

  ClearErrors
  FileOpen $0 $R0 r
  IfErrors DoneExtensionReadLoop
ExtensionDirsReadLoop:
  FileRead $0 $R3
  IfErrors ExtensionReadLoopNotFound
  Call StrStr
  Pop $R4
  StrCmp $R4 "" ExtensionDirsReadLoop
  FileClose $0
  StrCpy $R2 "true"
  Goto DoneExtensionReadLoop

ExtensionReadLoopNotFound:
  StrCpy $R2 "false"
  
DoneExtensionReadLoop:
  MessageBox MB_OK 'Path= "$R0"  GUID= "$R1"  Result="$R2" LastLine= "$R3" ExtDir="$R4"'
  Exch $R2
FunctionEnd

;Usage:
;Push "$INSTDIR\file.ext" ; file to modify
;Push "string" ; string that a line must begin with
;Push "string is blah" ; string to replace whole line with
;Call ReplaceLineStr

Function ReplaceLineStr
   Exch $R0 ; string to replace that whole line with
   Exch
   Exch $R1 ; string that line should start with
   Exch
   Exch 2
   Exch $R2 ; file
   Push $R3 ; file handle
   Push $R4 ; temp file
   Push $R5 ; temp file handle
   Push $R6 ; global
   Push $R7 ; input string length
   Push $R8 ; line string length
   Push $R9 ; global
   StrLen $R7 $R1
   GetTempFileName $R4
   FileOpen $R5 $R4 w
   FileOpen $R3 $R2 r
  ReadLoop:
   ClearErrors
   FileRead $R3 $R6
   IfErrors Done
   StrLen $R8 $R6
   StrCpy $R9 $R6 $R7 -$R8
   StrCmp $R9 $R1 0 +3
   FileWrite $R5 "$R0$\r$\n"
   Goto ReadLoop
   FileWrite $R5 $R6
   Goto ReadLoop
  Done:
   FileClose $R3
   FileClose $R5
   SetDetailsPrint none
   Delete $R2
   Rename $R4 $R2
   SetDetailsPrint both
   Pop $R9
   Pop $R8
   Pop $R7
   Pop $R6
   Pop $R4
   Pop $R3
   Pop $R2
   Pop $R1
   Pop $R0
FunctionEnd

Function un.GetWindowsVersion

   Push $R0
   Push $R1

   ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
   IfErrors 0 unlbl_winnt

   ; we are not NT
   ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion" VersionNumber
   StrCPY $OS '9X'
   StrCpy $R1 $R0 1
   StrCmp $R1 '4' 0 unlbl_error
   StrCpy $R1 $R0 3
   StrCmp $R1 '4.0' unlbl_win32_95
   StrCmp $R1 '4.9' unlbl_win32_ME unlbl_win32_98

   unlbl_win32_95:
     StrCpy $R0 '95'
   Goto unlbl_done

   unlbl_win32_98:
     StrCpy $R0 '98'
   Goto unlbl_done

   unlbl_win32_ME:
     StrCpy $R0 'ME'
   Goto unlbl_done


   unlbl_winnt:

   StrCpy $R1 $R0 1
   StrCPY $OS 'NT'
   StrCmp $R1 '3' ununlbl_winnt_x
   StrCmp $R1 '4' ununlbl_winnt_x
   StrCpy $R1 $R0 3
   StrCmp $R1 '5.0' unlbl_winnt_2000
   StrCmp $R1 '5.1' ununlbl_winnt_xP
   StrCmp $R1 '5.2' unlbl_winnt_2003
   StrCmp $R1 '6.0' unlbl_winnt_vista unlbl_error

   ununlbl_winnt_x:
     StrCpy $R0 'NT'
   Goto unlbl_done

   unlbl_winnt_2000:
     Strcpy $R0 '2000'
     Call un.IsUserAdmin
     pop $USERADMIN
   Goto unlbl_done

   ununlbl_winnt_xP:
     Strcpy $R0 'XP'
     StrCPY $OS 'XP'
     Call un.IsUserAdmin
     pop $USERADMIN
   Goto unlbl_done

   unlbl_winnt_2003:
     Strcpy $R0 '2003'
     StrCPY $OS 'XP'
     Call un.IsUserAdmin
     pop $USERADMIN
   Goto unlbl_done

   unlbl_winnt_vista:
     Strcpy $R0 'Vista'
     StrCPY $OS 'VS'
     Call un.IsUserAdmin
     pop $USERADMIN
   Goto unlbl_done

   unlbl_error:
     Strcpy $R0 ''
     StrCPY $OS 'XX'
   unlbl_done:

   Pop $R1
   Exch $R0

FunctionEnd

Function un.IsUserAdmin
Push $R0
Push $R1
Push $R2

ClearErrors
UserInfo::GetName
IfErrors UnWin9x
Pop $R1
UserInfo::GetAccountType
Pop $R2

StrCmp $R2 "Admin" unUser_Admin unContinue
unUser_Admin:
; Observation: I get here when running Win98SE. (Lilla)
; The functions UserInfo.dll looks for are there on Win98 too,
; but just don't work. So UserInfo.dll, knowing that admin isn't required
; on Win98, returns admin anyway. (per kichik)
; MessageBox MB_OK 'User "$R1" is in the Administrators group'
StrCpy $R0 "true"
StrCpy $NT "1"
Goto unuseradmindone

unContinue:
; You should still check for an empty string because the functions
; UserInfo.dll looks for may not be present on Windows 95. (per kichik)
StrCmp $R2 "" UnWin9x
StrCpy $R0 "false"
StrCpy $NT "0"
;MessageBox MB_OK 'User "$R1" is in the "$R2" group'
Goto unuseradmindone

UnWin9x:
; comment/message below is by UserInfo.nsi author:
; This one means you don't need to care about admin or
; not admin because Windows 9x doesn't either
;MessageBox MB_OK "Error! This DLL can't run under Windows 9x!"
StrCpy $R0 "true"
StrCpy $NT "0"

unuseradmindone:
;MessageBox MB_OK 'User= "$R1"  AccountType= "$R2"  IsUserAdmin= "$R0"'

Pop $R2
Pop $R1
Exch $R0
FunctionEnd



; GetParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables.
Function un.GetParameters

        Push $R0
        Push $R1
        Push $R2
        Push $R3

        StrCpy $R2 1
        StrLen $R3 $CMDLINE

        ;Check for quote or space
        StrCpy $R0 $CMDLINE $R2
        StrCmp $R0 '"' 0 +3
        StrCpy $R1 '"'
        Goto loop
        StrCpy $R1 " "

        loop:
        IntOp $R2 $R2 + 1
        StrCpy $R0 $CMDLINE 1 $R2
        StrCmp $R0 $R1 get
        StrCmp $R2 $R3 get
        Goto loop

        get:
        IntOp $R2 $R2 + 1
        StrCpy $R0 $CMDLINE 1 $R2
        StrCmp $R0 " " get
        StrCpy $R0 $CMDLINE "" $R2

        Pop $R3
        Pop $R2
        Pop $R1
        Exch $R0

FunctionEnd

Function StrStr
/*After this point:
  ------------------------------------------
  $R0 = SubString (input)
  $R1 = String (input)
  $R2 = SubStringLen (temp)
  $R3 = StrLen (temp)
  $R4 = StartCharPos (temp)
  $R5 = TempStr (temp)*/

  ;Get input from user
  Exch $R0
  Exch
  Exch $R1
  Push $R2
  Push $R3
  Push $R4
  Push $R5

  ;Get "String" and "SubString" length
  StrLen $R2 $R0
  StrLen $R3 $R1
  ;Start "StartCharPos" counter
  StrCpy $R4 0

  ;Loop until "SubString" is found or "String" reaches its end
  loop:
    ;Remove everything before and after the searched part ("TempStr")
    StrCpy $R5 $R1 $R2 $R4

    ;Compare "TempStr" with "SubString"
    StrCmp $R5 $R0 done
    ;If not "SubString", this could be "String"'s end
    IntCmp $R4 $R3 done 0 done
    ;If not, continue the loop
    IntOp $R4 $R4 + 1
    Goto loop
  done:

/*After this point:
  ------------------------------------------
  $R0 = ResultVar (output)*/

  ;Remove part before "SubString" on "String" (if there has one)
  StrCpy $R0 $R1 `` $R4

  ;Return output to user
  Pop $R5
  Pop $R4
  Pop $R3
  Pop $R2
  Pop $R1
  Exch $R0
FunctionEnd

Function un.StrStr
/*After this point:
  ------------------------------------------
  $R0 = SubString (input)
  $R1 = String (input)
  $R2 = SubStringLen (temp)
  $R3 = StrLen (temp)
  $R4 = StartCharPos (temp)
  $R5 = TempStr (temp)*/

  ;Get input from user
  Exch $R0
  Exch
  Exch $R1
  Push $R2
  Push $R3
  Push $R4
  Push $R5

  ;Get "String" and "SubString" length
  StrLen $R2 $R0
  StrLen $R3 $R1
  ;Start "StartCharPos" counter
  StrCpy $R4 0

  ;Loop until "SubString" is found or "String" reaches its end
  loop:
    ;Remove everything before and after the searched part ("TempStr")
    StrCpy $R5 $R1 $R2 $R4

    ;Compare "TempStr" with "SubString"
    StrCmp $R5 $R0 done
    ;If not "SubString", this could be "String"'s end
    IntCmp $R4 $R3 done 0 done
    ;If not, continue the loop
    IntOp $R4 $R4 + 1
    Goto loop
  done:

/*After this point:
  ------------------------------------------
  $R0 = ResultVar (output)*/

  ;Remove part before "SubString" on "String" (if there has one)
  StrCpy $R0 $R1 `` $R4

  ;Return output to user
  Pop $R5
  Pop $R4
  Pop $R3
  Pop $R2
  Pop $R1
  Exch $R0
FunctionEnd

; GetParameterValue
; Chris Morgan<cmorgan@alum.wpi.edu> 5/10/2004
; -Updated 4/7/2005 to add support for retrieving a command line switch
;  and additional documentation
;
; Searches the command line input, retrieved using GetParameters, for the
; value of an option given the option name.  If no option is found the
; default value is placed on the top of the stack upon function return.
;
; This function can also be used to detect the existence of just a
; command line switch like /OUTPUT  Pass the default and "OUTPUT"
; on the stack like normal.  An empty return string "" will indicate
; that the switch was found, the default value indicates that
; neither a parameter or switch was found.
;
; Inputs - Top of stack is default if parameter isn't found,
;  second in stack is parameter to search for, ex. "OUTPUT"
; Outputs - Top of the stack contains the value of this parameter
;  So if the command line contained /OUTPUT=somedirectory, "somedirectory"
;  will be on the top of the stack when this function returns
;
; Register usage
;$R0 - default return value if the parameter isn't found
;$R1 - input parameter, for example OUTPUT from the above example
;$R2 - the length of the search, this is the search parameter+2
;      as we have '/OUTPUT='
;$R3 - the command line string
;$R4 - result from StrStr calls
;$R5 - search for ' ' or '"'

Function un.GetParameterValue
  Exch $R0  ; get the top of the stack(default parameter) into R0
  Exch      ; exchange the top of the stack(default) with
            ; the second in the stack(parameter to search for)
  Exch $R1  ; get the top of the stack(search parameter) into $R1

  ;Preserve on the stack the registers used in this function
  Push $R2
  Push $R3
  Push $R4
  Push $R5

  Strlen $R2 $R1+2    ; store the length of the search string into R2

  Call un.GetParameters  ; get the command line parameters
  Pop $R3             ; store the command line string in R3

  # search for quoted search string
  StrCpy $R5 '"'      ; later on we want to search for a open quote
  Push $R3            ; push the 'search in' string onto the stack
  Push '"/$R1='       ; push the 'search for'
  Call un.StrStr         ; search for the quoted parameter value
  Pop $R4
  StrCpy $R4 $R4 "" 1   ; skip over open quote character, "" means no maxlen
  StrCmp $R4 "" "" next ; if we didn't find an empty string go to next

  # search for non-quoted search string
  StrCpy $R5 ' '      ; later on we want to search for a space since we
                      ; didn't start with an open quote '"' we shouldn't
                      ; look for a close quote '"'
  Push $R3            ; push the command line back on the stack for searching
  Push '/$R1='        ; search for the non-quoted search string
  Call un.StrStr
  Pop $R4

  ; $R4 now contains the parameter string starting at the search string,
  ; if it was found
next:
  StrCmp $R4 "" check_for_switch ; if we didn't find anything then look for
                                 ; usage as a command line switch
  # copy the value after /$R1= by using StrCpy with an offset of $R2,
  # the length of '/OUTPUT='
  StrCpy $R0 $R4 "" $R2  ; copy commandline text beyond parameter into $R0
  # search for the next parameter so we can trim this extra text off
  Push $R0
  Push $R5            ; search for either the first space ' ', or the first
                      ; quote '"'
                      ; if we found '"/output' then we want to find the
                      ; ending ", as in '"/output=somevalue"'
                      ; if we found '/output' then we want to find the first
                      ; space after '/output=somevalue'
  Call un.StrStr         ; search for the next parameter
  Pop $R4
  StrCmp $R4 "" done  ; if 'somevalue' is missing, we are done
  StrLen $R4 $R4      ; get the length of 'somevalue' so we can copy this
                      ; text into our output buffer
  StrCpy $R0 $R0 -$R4 ; using the length of the string beyond the value,
                      ; copy only the value into $R0
  goto done           ; if we are in the parameter retrieval path skip over
                      ; the check for a command line switch

; See if the parameter was specified as a command line switch, like '/output'
check_for_switch:
  Push $R3            ; push the command line back on the stack for searching
  Push '/$R1'         ; search for the non-quoted search string
  Call un.StrStr
  Pop $R4
  StrCmp $R4 "" done  ; if we didn't find anything then use the default
  StrCpy $R0 ""       ; otherwise copy in an empty string since we found the
                      ; parameter, just didn't find a value

done:
  Pop $R5
  Pop $R4
  Pop $R3
  Pop $R2
  Pop $R1
  Exch $R0 ; put the value in $R0 at the top of the stack
FunctionEnd