;
; BEGIN FLOCK MPL
;
; Version: MPL 1.1/GPL 2.0/LGPL 2.1
;
; The contents of this file are subject to the Mozilla Public License Version
; 1.1 (the "License"); you may not use this file except in compliance with
; the License. You may obtain a copy of the License at
; http://www.mozilla.org/MPL/
;
; Software distributed under the License is distributed on an "AS IS" basis,
; WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
; for the specific language governing rights and limitations under the
; License.
;
; The Original Code is Flock Browser code.
;
; The Initial Developer of the Original Code is
; Flock Inc.
; Portions created by the Initial Developer are Copyright (C) 2005-2008
; the Initial Developer. All Rights Reserved.
;
; Contributor(s):
;
; Alternatively, the contents of this file may be used under the terms of
; either of the GNU General Public License Version 2 or later (the "GPL"),
; or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
; in which case the provisions of the GPL or the LGPL are applicable instead
; of those above. If you wish to allow use of your version of this file only
; under the terms of either the GPL or the LGPL, and not to allow others to
; use your version of this file under the terms of the MPL, indicate your
; decision by deleting the provisions above and replace them with the notice
; and other provisions required by the GPL or the LGPL. If you do not delete
; the provisions above, a recipient may use your version of this file under
; the terms of any one of the MPL, the GPL or the LGPL.
;
; END FLOCK MPL
;

; adding slightly larger in memory, but smaller on disk compression (lzma)
SetCompressor lzma

!include "MUI.nsh"
!include "logiclib.nsh"
ReserveFile "config.ini"
ReserveFile "graphics\\installPanel.bmp"
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
!define PRODUCT_NAME "Flock"
!define PRODUCT_VERSION_NUMBER "1.1" ; %MOZ_APP_VERSION
!define PRODUCT_VERSION "1.1"
!define PRODUCT_NAMEEXT ""
!define GECKOVERSION "1.8.1.11"                  ; GECKO ENGINE VER
!define CURRENTVERSION "${PRODUCT_VERSION} (en-US)"
!define PRODUCT_PUBLISHER "Flock"
!define PRODUCT_WEB_SITE "http://www.flock.com"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}${PRODUCT_NAMEEXT}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_KEY "Software\${PRODUCT_NAME}${PRODUCT_NAMEEXT}"
!define PRODUCT_UNINST_URL "http://www.flock.com/uninstall/${PRODUCT_NAME}/${PRODUCT_VERSION_NUMBER}"
!define SYSREQMSG "${PRODUCT_NAME} requires the following minimum CPU and Memory to operate:$\r$\n$\r$\nCPU: 233 MHz$\r$\nRAM: 64 MB$\r$\nHard Drive Space: 35MB$\r$\n$\r$\nYour computer does not meet these minimum requirements. Please Click OK to exit the installation."
!define UNSUPPORTED "${PRODUCT_NAME} will not run on Windows $R0. This version of Security Suite runs on the following operating systems:$\r$\nWindows 98, 98SE,$\r$\nWindows ME$\r$\nWindows 2000$\r$\nWindows XP, Windows XP SP2$\r$\n$\r$\nPlease click OK to exit the installation."
!define APP_NAME "flock.exe"
!define EXENAME "FLOCK\FLOCK.EXE"
!define APPCLASSNAME "MozillaUIWindowClass"
!define TEMP1 $R0
!define PRODUCT_INSTALL_URL "http://metrics.flock.com/collect.php"
VAR NT
VAR OS
VAR USERADMIN
VAR PATH_SPA
VAR DT_ICON
VAR QL_ICON
VAR ANONSTAT
VAR SETDEFAULTBROWSER

; MUI Settings
!define LOGO_IMAGE "flockWinInstall.ico"
!define MUI_ABORTWARNING
!define MUI_ICON "flockWinInstall.ico"
!define MUI_UNICON "flockWinUnInstall.ico"
; use this to set your own build path vs the hardcoded one
!include /NONFATAL "thisismysourcedir.nsi"
!ifndef SOURCEDIR
 !define SOURCEDIR "..\..\..\..\..\..\..\objectdir\dist\flock"
!endif
;  Visual Customizations.
WindowIcon on
InstProgressFlags smooth
;RequestExecutionLevel user

BrandingText /TRIMRIGHT "${PRODUCT_WEB_SITE}"
SetDateSave on
SetDatablockOptimize on
CRCCheck on
AddBrandingImage left 100

!macro MUI_PAGE_FINISH_MOD

  !verbose push
  !verbose ${MUI_VERBOSE}

  !insertmacro MUI_PAGE_INIT

  !insertmacro MUI_SET MUI_${MUI_PAGE_UNINSTALLER_PREFIX}FINISHPAGE

  !insertmacro MUI_DEFAULT MUI_FINISHPAGE_TITLE "$(MUI_${MUI_PAGE_UNINSTALLER_PREFIX}TEXT_FINISH_INFO_TITLE)"
  !insertmacro MUI_DEFAULT MUI_FINISHPAGE_TEXT "$(MUI_${MUI_PAGE_UNINSTALLER_PREFIX}TEXT_FINISH_INFO_TEXT)"
  !insertmacro MUI_DEFAULT MUI_FINISHPAGE_BUTTON "$(MUI_BUTTONTEXT_FINISH)"
  !insertmacro MUI_DEFAULT MUI_FINISHPAGE_TEXT_REBOOT "$(MUI_${MUI_PAGE_UNINSTALLER_PREFIX}TEXT_FINISH_INFO_REBOOT)"
  !insertmacro MUI_DEFAULT MUI_FINISHPAGE_TEXT_REBOOTNOW "$(MUI_TEXT_FINISH_REBOOTNOW)"
  !insertmacro MUI_DEFAULT MUI_FINISHPAGE_TEXT_REBOOTLATER "$(MUI_TEXT_FINISH_REBOOTLATER)"
  !insertmacro MUI_DEFAULT MUI_FINISHPAGE_RUN_TEXT "$(MUI_TEXT_FINISH_RUN)"
  !insertmacro MUI_DEFAULT MUI_FINISHPAGE_SHOWREADME_TEXT "$(MUI_TEXT_FINISH_SHOWREADME)"
  !insertmacro MUI_DEFAULT MUI_FINISHPAGE_LINK_COLOR "000080"

  !ifndef MUI_VAR_HWND
    Var /GLOBAL MUI_HWND
    !define MUI_VAR_HWND
  !endif

  !ifndef MUI_PAGE_UNINSTALLER
    !ifndef MUI_FINISHPAGE_NOAUTOCLOSE
      AutoCloseWindow true
    !endif
  !endif

;  !ifdef MUI_FINISHPAGE_RUN | MUI_FINISHPAGE_SHOWREADME
;    !ifndef MUI_VAR_NOABORTWARNING
;      !define MUI_VAR_NOABORTWARNING
;      Var /GLOBAL MUI_NOABORTWARNING
;    !endif
;  !endif

  PageEx ${MUI_PAGE_UNINSTALLER_FUNCPREFIX}custom

    PageCallbacks ${MUI_PAGE_UNINSTALLER_FUNCPREFIX}mui.FinishPre_${MUI_UNIQUEID} ${MUI_PAGE_UNINSTALLER_FUNCPREFIX}mui.FinishLeave_${MUI_UNIQUEID}

    Caption " "

  PageExEnd

  !insertmacro MUI_FUNCTION_FINISHPAGE ${MUI_PAGE_UNINSTALLER_FUNCPREFIX}mui.FinishPre_${MUI_UNIQUEID} ${MUI_PAGE_UNINSTALLER_FUNCPREFIX}mui.FinishLeave_${MUI_UNIQUEID}

  !insertmacro MUI_UNSET MUI_FINISHPAGE_TITLE
  !insertmacro MUI_UNSET MUI_FINISHPAGE_TITLE_3LINES
  !insertmacro MUI_UNSET MUI_FINISHPAGE_TEXT
  !insertmacro MUI_UNSET MUI_FINISHPAGE_TEXT_LARGE
  !insertmacro MUI_UNSET MUI_FINISHPAGE_BUTTON
  !insertmacro MUI_UNSET MUI_FINISHPAGE_TEXT_REBOOT
  !insertmacro MUI_UNSET MUI_FINISHPAGE_TEXT_REBOOTNOW
  !insertmacro MUI_UNSET MUI_FINISHPAGE_TEXT_REBOOTLATER
  !insertmacro MUI_UNSET MUI_FINISHPAGE_RUN
  !insertmacro MUI_UNSET MUI_FINISHPAGE_RUN_TEXT
  !insertmacro MUI_UNSET MUI_FINISHPAGE_RUN_PARAMETERS
  !insertmacro MUI_UNSET MUI_FINISHPAGE_RUN_NOTCHECKED
  !insertmacro MUI_UNSET MUI_FINISHPAGE_RUN_FUNCTION
  !insertmacro MUI_UNSET MUI_FINISHPAGE_SHOWREADME
  !insertmacro MUI_UNSET MUI_FINISHPAGE_SHOWREADME_TEXT
  !insertmacro MUI_UNSET MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
  !insertmacro MUI_UNSET MUI_FINISHPAGE_SHOWREADME_FUNCTION
  !insertmacro MUI_UNSET MUI_FINISHPAGE_LINK
  !insertmacro MUI_UNSET MUI_FINISHPAGE_LINK_LOCATION
  !insertmacro MUI_UNSET MUI_FINISHPAGE_LINK_COLOR
  !insertmacro MUI_UNSET MUI_FINISHPAGE_NOREBOOTSUPPORT

  !insertmacro MUI_UNSET MUI_FINISHPAGE_ABORTWARNINGCHECK

  !verbose pop
!macroend

!define MUI_WELCOMEFINISHPAGE_BITMAP "graphics\installpanel.bmp"
; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!define MUI_LICENSEPAGE_RADIOBUTTONS
!insertmacro MUI_PAGE_LICENSE "eula.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
Page custom SetCustom CreatePrefs ""
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\flock\flock.exe"
!insertmacro MUI_PAGE_FINISH_MOD

; Uninstaller pages
!insertmacro MUI_UNPAGE_CONFIRM ;Use built-in confirmation page
;UninstPage custom un.NoConfirmPage ;Custom page
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"
;!undef ${MUI_BUTTONTEXT_FINISH}
!insertmacro MUI_DEFAULT MUI_BUTTONTEXT_FINISH "Done"
; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "Flock_Setup.exe"
ShowInstDetails show
;ShowUnInstDetails show
ShowUninstDetails hide

Function DetermineInstallDir
  StrCMP $USERAdmin "false" LimitedUser AdminUser
LimitedUser:
  StrCpy $INSTDIR "$PROFILE\Flock"
  Goto InstallDirDecided
AdminUser:
  StrCpy $INSTDIR "$PROGRAMFILES\Flock"
InstallDirDecided:
FunctionEnd

Function CheckForExistingInstall
  StrCpy $SETDEFAULTBROWSER "false"
  ClearErrors
  StrCpy $R1 ${PRODUCT_UNINST_KEY}
  ReadRegstr $R0 HKLM $R1 "UninstallString"
  IfErrors FinishGuiInit PossibleUpgrade
  ;IfFileExists $R0 ClobberOld FinishGuiInit

  PossibleUpgrade:
  IfFileExists $R0 QueryUserToUpgrade FinishGuiInit

  QueryUserToUpgrade:
  MessageBox MB_OKCANCEL|MB_DEFBUTTON1|MB_ICONEXCLAMATION "Note: installing ${PRODUCT_NAME} will remove previous version of ${PRODUCT_NAME} and migrate your settings." IDOK ClobberOld IDCANCEL NoClobberOld

  ClobberOld:
  ; We need to check if Flock was the default browser first so we can re-enable it as the default browser
  ReadRegstr $R1 HKLM "SOFTWARE\Clients\StartMenuInternet\" ""
  StrCmp $R1 "FLOCK.EXE" FLOCK NOTFLOCK
  FLOCK:
  StrCpy $SETDEFAULTBROWSER "true"
  NOTFLOCK:

  ExecWait '"$R0" /S /DELETEPROFILE=NO /LAUNCHUNINSTALL=NO'
  StrLen $R2 "\uninst.exe"
  StrCpy $R0 $R0 -$R2
  StrCpy $INSTDIR $R0
  Goto FinishGuiInit

  NoClobberOld:
  Abort

  FinishGuiInit:
FunctionEnd


Section "Application" SEC01
  SetOutPath $INSTDIR
  AddSize 18347
  ClearErrors
  Setoverwrite Try

  !include "installer-files.nsi"

  GetFullPathName /SHORT $PATH_SPA "$INSTDIR\${EXENAME}"

  File /a "/oname=$WINDIR\SetBrowser.exe" "SetBrowser.exe"
  File /a "/oname=$WINDIR\SetBrowser.ini" "SetBrowser.ini"
  File /a "RuncmdFile.exe"
  File /a "perms.cmd"
  CreateDirectory $INSTDIR\flock\uninstall
  File /a "install_flash_player.exe"
  File /a "flock.ico"
  SetOutPath $INSTDIR\flock
  File /a "yahootoolbar.xpi"
  CreateDirectory $INSTDIR\flock\uninstall
  SetOutPath $INSTDIR\flock\uninstall
  File /a "/oname=$INSTDIR\flock\uninstall\helper.exe" "flset.exe"
  SetOutPath $INSTDIR
SectionEnd

Section "Icons" SEC02
  SetOutPath $INSTDIR
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  ${IF} $USERADMIN  == "false"
  ${ANDIF} $OS == "VS"
    SetShellVarContext Current
  	DetailPrint "Limited User"
    RMDir /r "$SMPROGRAMS\Flock"
    Delete "$QUICKLAUNCH\Flock.Lnk"
    Delete "$DESKTOP\Flock.Lnk"
    CreateDirectory "$SMPROGRAMS\Flock"
    RMDir /r "$TEMP/FlockTmp"
    CreateDirectory "$TEMP\FlockTmp"
    CreateShortCut "$TEMP\Flocktmp\Flock.lnk" "$INSTDIR\${EXENAME}"
    CreateShortCut "$TEMP\Flocktmp\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
    CreateShortCut "$TEMP\Flocktmp\Uninstall.lnk" "$INSTDIR\uninst.exe"
    CopyFiles /SILENT "$TEMP\FlockTmp\*" "$SMPROGRAMS\Flock"
    RMDir /r "$TEMP/FlockTmp"
;    CreateShortCut "$SMPROGRAMS\Flock\Flock.lnk" "$INSTDIR\${EXENAME}"
;    CreateShortCut "$SMPROGRAMS\Flock\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
;    CreateShortCut "$SMPROGRAMS\Flock\Uninstall.lnk" "$INSTDIR\uninst.exe"
  ${ELSEIF} $OS == "VS"
  ${ORIF} $USERADMIN == "false"
  SetShellVarContext Current
    Delete "$SMPROGRAMS\Flock\Uninstall.lnk"
    Delete "$SMPROGRAMS\Flock\Website.lnk"
    RMDir /r "$SMPROGRAMS\Flock"
    Delete "$QUICKLAUNCH\Flock.Lnk"
    Delete "$DESKTOP\Flock.Lnk"
    CreateDirectory "$SMPROGRAMS\Flock"
    CreateShortCut "$SMPROGRAMS\Flock\Flock.lnk" "$INSTDIR\${EXENAME}"
    CreateShortCut "$SMPROGRAMS\Flock\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
    CreateShortCut "$SMPROGRAMS\Flock\Uninstall.lnk" "$INSTDIR\uninst.exe"
  ${ELSE}
  SetShellVarContext all
    CreateDirectory "$SMPROGRAMS\Flock"
    CreateShortCut "$SMPROGRAMS\Flock\Flock.lnk" "$INSTDIR\${EXENAME}"
    CreateShortCut "$SMPROGRAMS\Flock\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
    CreateShortCut "$SMPROGRAMS\Flock\Uninstall.lnk" "$INSTDIR\uninst.exe"
  ${ENDIF}

  ${IF} $DT_ICON == "1"
    CreateShortCut "$DESKTOP\Flock.lnk" "$INSTDIR\${EXENAME}"
  ${ENDIF}

  ${IF} $QL_ICON == "1"
    CreateShortCut "$QUICKLAUNCH\Flock.lnk" "$INSTDIR\${EXENAME}"
  ${ENDIF}

  ${IF} $ANONSTAT == "0" ; Disable anonymous stats collecting.
    SetOutPath $INSTDIR\flock\defaults\pref
    File /a "disablestats.js"
    SetOutPath $INSTDIR
  ${ENDIF}

  ; Set permissions on the flock browser folder.
  ;------------------------------------------------
  StrCmp $NT "0" SkipPermissions
  IfFileExists "$SYSDIR\cacls.exe" 0 SkipPermissions
     Push $INSTDIR\PERMS.CMD ; file to modify
     Push 'cacls.exe Flock\*.* /T /E /C /G Everyone:R >NUL'
     Push 'cacls.exe "$INSTDIR\*.*" /T /E /C /G Everyone:R'
     Call ReplaceLineStr
     ExecWait '"$INSTDIR\RunCmdFile.exe" "$INSTDIR\PERMS.CMD"'
  SkipPermissions:
SectionEnd

Section "Configuration" SEC03
  ; Inform flock that an install has started...
  inetc::post "{ $\"product$\": $\"Flock$\", $\"edition$\": $\"$\", $\"install start$\": 1 }" "${PRODUCT_INSTALL_URL}" "$PLUGINSDIR\post_reply.htm"

  ; Syntax: WriteRegStr rootkey subkey keyname value
  WriteRegStr HKCU "Software\Flock\Flock\" "CurrentVersion" "${CURRENTVERSION}"
  WriteRegStr HKLM "Software\Flock\Flock\" "CurrentVersion" "${CURRENTVERSION}"
  WriteRegStr HKLM "Software\Flock\Flock\" "Extensions" "$INSTDIR\flock\Extensions"
  WriteRegStr HKLM "Software\Flock\Flock\" "Plugins" "$INSTDIR\flock\Plugins"

  ; Persistance at work.  All keys are rewritten to registry at the end of the install
  ; This also allows debugging, as well as installs to verify the information.
  ; Any new keys should also be added below.

  WriteRegStr HKCU "${PRODUCT_KEY}" "Install Directory" $INSTDIR

  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\App Paths\${APP_NAME}" "PATH" "$INSTDIR\flock"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\App Paths\${APP_NAME}" "" "$INSTDIR\${EXENAME}"
  ; Xpi Support
  ReadregStr $0 HKCR "xpi_auto_file" ""
  StrCmp $0 "Flock Theme or Extension Package" Deletekeys IgnoreKeys
  DeleteKeys:
    ;; This is to remove xpi affilliation with flock for people using previous versions of the installer.
    DeleteRegKey HKCR ".xpi"
    DeleteRegKey HKCR "xpi_auto_file"
    DeleteRegKey HKLM "SOFTWARE\Classes\MIME\Database\Content Type\application/x-xpinstall;app=Flock"
    DeleteRegKey HKLM "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.xpi"
    DeleteRegKey HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.xpi\OpenWithProgids"
    DeleteRegKey HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.xpi"
    DeleteRegKey HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.xpi\OpenWithList"
    DeleteRegKey HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.xpi\OpenWithList"
  IgnoreKeys:

  WriteRegstr HKCR "Applications\flock.exe\shell\open\command" "" '"$INSTDIR\${EXENAME}" "%1"'
  WriteRegStr HKCU "Software\Classes\Applications\flock.exe\shell\open\command" "" '"$INSTDIR\${EXENAME}" "%1"'
;  WriteRegBin HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.xpi\OpenWithProgids" "xpi_auto_file" ""
;  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.xpi" "Application" "${APP_NAME}"
;  WriteRegstr HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.xpi\OpenWithList" "MRUList" "a"
;  WriteRegstr HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.xpi\OpenWithList" "a" "${APP_NAME}"
  ; Mozilla Compatible Versioning information.
  WriteRegStr HKLM "SOFTWARE\Flock\Flock" "CurrentVersion" "${CURRENTVERSION}"
  WriteRegStr HKLM "SOFTWARE\Flock\Flock\${CURRENTVERSION}\Main" "Install Directory" "$INSTDIR\flock"
  WriteRegStr HKLM "SOFTWARE\Flock\Flock\${CURRENTVERSION}\Main" "PathToExe" "$INSTDIR\${EXENAME}"

  WriteRegStr HKLM "SOFTWARE\Flock\Flock ${PRODUCT_VERSION}" "GeckoVer" "${GECKOVERSION}"
  WriteRegStr HKLM "SOFTWARE\Flock\Flock ${PRODUCT_VERSION}\flock" "PathToExe" "$INSTDIR\${EXENAME}"
  WriteRegStr HKLM "SOFTWARE\Flock\Flock ${PRODUCT_VERSION}\Extensions" "Components" "$INSTDIR\flock\Components"
  WriteRegStr HKLM "SOFTWARE\Flock\Flock ${PRODUCT_VERSION}\Extensions" "Plugins" "$INSTDIR\flock\Plugins"

  ; JMC - Keys required for flash plugin installer
  WriteRegStr HKLM "SOFTWARE\Mozilla\Flock" "GeckoVer" "${GECKOVERSION}"
  WriteRegStr HKLM "SOFTWARE\Mozilla\Flock\flock" "PathToExe" "$INSTDIR\${EXENAME}"

  WriteRegStr HKLM "SOFTWARE\Mozilla\Flock\Extensions" "Plugins" "$INSTDIR\flock\plugins"
  WriteRegStr HKLM "SOFTWARE\Mozilla\Flock\Extensions" "Components" "$INSTDIR\flock\components"

  ; Set Program Access and Defaults
  StrCMP $OS "VS" XP
  StrCMP $OS "XP" XP NOTXP
  XP:
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}" "" "Flock"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\DefaultIcon" "" '$INSTDIR\${EXENAME},0'
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\shell\open\command\" "" '$INSTDIR\${EXENAME}'
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\shell\properties" "" "Flock &Options"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\shell\properties\command\" "" '"$INSTDIR\${EXENAME} -preferences"'
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\shell\safemode" "" "Flock &Safe Mode"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\shell\safemode\command\" "" '"$INSTDIR\${EXENAME} -safe-mode"'

    WriteRegDword HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\InstallInfo" "IconsVisible" "1"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\InstallInfo" "HideIconsCommand" '"$INSTDIR\flock\uninstall\helper.exe" /HideShortcuts'
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\InstallInfo" "ReinstallCommand" '"$INSTDIR\flock\uninstall\helper.exe" /SetAsDefaultAppGlobal'
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\InstallInfo" "ShowIconsCommand" '"$INSTDIR\flock\uninstall\helper.exe" /ShowShortcuts'

    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities" "ApplicationDescription" "The Social Web Browser."
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities" "ApplicationIcon" "$INSTDIR\${EXENAME},0"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities" "ApplicationName" "Flock"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\FileAssociations" ".htm"   "FlockHTML"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\FileAssociations" ".html"  "FlockHTML"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\FileAssociations" ".shtml" "FlockHTML"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\FileAssociations" ".xht"   "FlockHTML"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\FileAssociations" ".xhtml" "FlockHTML"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\URLAssociations" "ftp"    "FlockURL"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\URLAssociations" "gopher" "FlockURL"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\URLAssociations" "http"   "FlockURL"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\URLAssociations" "https"  "FlockURL"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\StartMenu" "StartMenuInternet" "FLOCK.EXE"

  GetFullPathName /SHORT $8 "$INSTDIR\${EXENAME}"
  StrCpy $0 "SOFTWARE\Classes"
  StrCpy $2 "$8 -requestPending -osint -url $\"%1$\""
  ${IF} $USERAdmin  == "false"
  SetShellVarContext Current
  ${ELSE}
  SetShellVarContext all
  ${ENDIF}
  ; Associate the file handlers with FlockHTML
  ;WriteRegStr SHCTX "$0\.htm"   "" "FlockHTML"
  ;WriteRegStr SHCTX "$0\.html"  "" "FlockHTML"
  ;WriteRegStr SHCTX "$0\.shtml" "" "FlockHTML"
  ;WriteRegStr SHCTX "$0\.xht"   "" "FlockHTML"
  ;WriteRegStr SHCTX "$0\.xhtml" "" "FlockHTML"
 
    WriteRegStr SHCTX "$0\FlockHTML" "" "Flock Document"
    WriteRegStr SHCTX "$0\FlockHTML" "FriendlyTypeName" "Flock Document"
    WriteRegStr SHCTX "$0\FlockHTML\DefaultIcon" "" '"$INSTDIR\${EXENAME}",1'
    WriteRegStr SHCTX "$0\FlockHTML\shell\open\command" "" "$INSTDIR\${EXENAME} -requestPending -osint -url $\"%1$\""
    WriteRegStr SHCTX "$0\FlockHTML\shell\open\ddeexec" "" ""
    WriteRegStr SHCTX "$0\FlockHTML\shell\open\ddeexec" "NoActivateHandler" ""
    WriteRegStr SHCTX "$0\FlockHTML\shell\open\ddeexec\Application" "" "Flock"
    WriteRegStr SHCTX "$0\FlockHTML\shell\open\ddeexec\Topic" "" "WWW_OpenURL"

    WriteRegStr SHCTX "$0\FlockURL" "" "Flock URL"
    WriteRegStr SHCTX "$0\FlockURL" "FriendlyTypeName" "Flock URL"
    WriteRegStr SHCTX "$0\FlockURL" "URL Protocol" ""
    WriteRegDword SHCTX "$0\FlockURL" "EditFlags" "2"
    WriteRegStr SHCTX "$0\FlockURL\DefaultIcon" "" '"$INSTDIR\${EXENAME}",1'
    WriteRegStr SHCTX "$0\FlockURL\shell\open\command" "" "$INSTDIR\${EXENAME} -requestPending -osint -url $\"%1$\""
    WriteRegStr SHCTX "$0\FlockURL\shell\open\ddeexec" "" ""
    WriteRegStr SHCTX "$0\FlockURL\shell\open\ddeexec" "NoActivateHandler" ""
    WriteRegStr SHCTX "$0\FlockURL\shell\open\ddeexec\Application" "" "Flock"
    WriteRegStr SHCTX "$0\FlockURL\shell\open\ddeexec\Topic" "" "WWW_OpenURL"
 
    WriteRegStr HKLM "SOFTWARE\RegisteredApplications" "Flock" "Software\Clients\StartMenuInternet\flock.exe\Capabilities"
  NOTXP:

  ; Now that the options have been set, delete the config settings, rewrite the key, and set a finish flag
  ; DeleteRegKey HKEY_CURRENT_USER "${PRODUCT_KEY}"
  WriteRegStr HKCU "${PRODUCT_KEY}" "Install_Complete" "1"
  WriteRegStr HKCU "${PRODUCT_KEY}" "Install Directory" "$INSTDIR"
  ; Done!

  ; Add Windows Media Player Compatibility
  ReadRegStr $R0 HKLM "Software\Microsoft\MediaPlayer\ShimInclusionList\${APP_NAME}" ""
  IfErrors WriteMMP_Key SkipMMP_Key
  WriteMMP_Key:
    WriteRegStr HKLM "Software\Microsoft\MediaPlayer\ShimInclusionList\${APP_NAME}" "" ""
  SkipMMP_Key:
    ClearErrors

  ; Import quicktime plugin.
  ReadRegStr $R0 HKLM "Software\Apple Computer, Inc.\Quicktime" "InstallDir"
  IfErrors NoQt QTInstall
  QtInstall:
    CopyFiles /SILENT "$R0\Plugins\nsIQTScriptablePlugin.xpt" "$INSTDIR\flock\Plugins\nsIQTScriptablePlugin.xpt"
  NoQt:

  ExecWait '"$INSTDIR\install_flash_player.exe" /s'

  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"

  ;Check if the previous version of flock was the default browser and if so then make this one the
  ; new default browser
  StrCMP $OS "XP" 0 NOTFLOCKDEFBROWSER
  StrCmp $SETDEFAULTBROWSER "false" NOTFLOCKDEFBROWSER FLOCKDEFBROWSER
  FLOCKDEFBROWSER:
  WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\" "" "FLOCK.EXE"
  NOTFLOCKDEFBROWSER:

  ; Inform flock that an install has finished...
  inetc::post "{ $\"product$\": $\"Flock$\", $\"edition$\": $\"$\", $\"install complete$\": 1 }" "${PRODUCT_INSTALL_URL}" "$PLUGINSDIR\post_reply.htm"
  Delete "$PLUGINSDIR\post_reply.htm"

SectionEnd

Section Uninstall
  Push $R0
  Call un.appCheck
  SetShellVarContext Current

  Push "DELETEPROFILE"
  Push "ASK"
  Call un.GetParameterValue
  Pop $R0
  StrCmp $R0 "ASK" CheckClobberPrefs MaybeClobberPrefs
  MaybeClobberPrefs:
  StrCmp $R0 "YES" ClobberPrefs NoClobberPrefs
  CheckClobberPrefs:
  MessageBox MB_YESNO|MB_DEFBUTTON2|MB_ICONEXCLAMATION "If you're upgrading Flock, or if you expect to reinstall Flock in the future, or perhaps import your Flock settings or favorites into another application, we recommend keeping your Flock profile intact. Would you like to keep your Flock profile?" IDYES NoClobberPrefs IDNO ClobberPrefs
  Goto NoClobberPrefs
  ClobberPrefs:
  StrCMP $OS "VS" unXP
  StrCMP $OS "XP" unXP unNOTXP
  unXP:
  RMDir /r "$LOCALAPPDATA\Flock\Browser"
  unNOTXP:
  RMDir /r "$APPDATA\Flock\Browser"
  NoClobberPrefs:

  SetAutoClose true
  ${IF} $USERAdmin  == "false"
  ${ORIF} $OS == "VS"
    SetShellVarContext Current
    Delete "$SMPROGRAMS\Flock\Uninstall.lnk"
    Delete "$SMPROGRAMS\Flock\Website.lnk"
    RMDir /r "$SMPROGRAMS\Flock"
    Delete "$QUICKLAUNCH\Flock.Lnk"
    Delete "$DESKTOP\Flock.Lnk"
  ${ELSE}
    SetShellVarContext all
    Delete "$SMPROGRAMS\Flock\Uninstall.lnk"
    Delete "$SMPROGRAMS\Flock\Website.lnk"
    RMDir /r "$SMPROGRAMS\Flock"
    Delete "$QUICKLAUNCH\Flock.Lnk"
    Delete "$DESKTOP\Flock.Lnk"
  ${ENDIF}
  !include "installer-unfiles.nsi"
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\RunCmdFile.exe"
  Delete "$INSTDIR\perms.cmd"
  Delete "$INSTDIR\NSB-PERMs.cmd"
  Delete "$INSTDIR\FLSET.EXE"
  Delete "$INSTDIR\install_flash_player.exe"
  Delete "$INSTDIR\flock\yahootoolbar.xpi"

  
  ; Regkey Removal
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKCR "FlockHTML"
  DeleteRegKey HKCR "FlockURL"
  DeleteRegKey HKCU "Software\Flock"
  DeleteRegKey HKLM "SOFTWARE\Classes\FlockHTML"
  DeleteRegKey HKLM "SOFTWARE\Classes\FlockURL"
  DeleteRegKey HKLM "SOFTWARE\Clients\StartMenuInternet\flock.exe"
  DeleteRegKey HKLM "SOFTWARE\Flock"
  DeleteRegKey HKLM "SOFTWARE\Mozilla\Flock"
  DeleteRegValue HKLM "SOFTWARE\RegisteredApplications" "Flock"
  
	; Two checks need to occur here.
	; First check starts below, check for flock as the default 
	; listed in "Set Program Access and Defaults"
	; This may be present in HKCU or HKLM
	  
  ReadRegstr $R0 HKCU "SOFTWARE\Clients\StartMenuInternet\" ""
  ReadRegstr $R1 HKLM "SOFTWARE\Clients\StartMenuInternet\" ""
  ${IF} $R0 == "FLOCK.EXE"
  ${ORIF} $R1 == "FLOCK.EXE"
  ; Set Internet Explorer as the default web browser
  ; in "set program access and defaults"
  ReadRegStr $R0 HKLM "SOFTWARE\Clients\StartMenuInternet\IEXPLORE.EXE\InstallInfo" "ShowIconsCommand"
  ReadRegStr $R1 HKLM "SOFTWARE\Clients\StartMenuInternet\IEXPLORE.EXE\InstallInfo" "ReinstallCommand"
  ;WriteRegStr HKCU "SOFTWARE\Clients\StartMenuInternet" "" "IEXPLORE.EXE"
  WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet" "" "IEXPLORE.EXE"
  ; Vista Home locks trying to run the ie re-register command, so skip it for vista.
  ${IF} $OS == "VS"
    ExecWait '$R0'
  ${ELSE}
    ExecWait '$R0'
    Exec '$R1'
  ${ENDIF}	
${ENDIF}
	
	; Notify the system of a default browser change
  SendMessage ${HWND_BROADCAST} ${WM_SETTINGCHANGE} 0 "Software\Clients\StartMenuInternet" $R0

	; The second check starts here.  
	; Check for Flock registered as the file type handler
	; and reset it if found (separate logic for vista, as there is no HKLM access there)

	; Get into the right context
	; for non-admins or vista, it is ALWAYS HKCU
	
  ${IF} $USERADMIN  == "false"
  SetShellVarContext Current
  ${ELSE}
  SetShellVarContext all
  ${ENDIF}	

  StrCpy $0 "SOFTWARE\Classes"
  ReadRegStr $R0 SHCTX "$0\.htm" ""
  ${IF} $R0 == "FlockHTML"
  WriteRegStr SHCTX "$0\.htm"   "" "htmlfile"
  WriteRegStr SHCTX "$0\.html"  "" "htmlfile"
  WriteRegStr SHCTX "$0\.shtml" "" "htmlfile"
  WriteRegStr SHCTX "$0\.xht"   "" "htmlfile"
  WriteRegStr SHCTX "$0\.xhtml" "" "htmlfile"
  ${ENDIF}

  ; Only vista has these keys
  ${IF} $OS == "VS"
  WriteRegStr HKCU "Software\Microsoft\Windows\Shell\Associations\UrlAssociations\ftp\UserChoice" "Progid"  "IE.FTP"
  WriteRegStr HKCU "Software\Microsoft\Windows\Shell\Associations\UrlAssociations\http\UserChoice" "Progid"  "IE.HTTP"
  WriteRegStr HKCU "Software\Microsoft\Windows\Shell\Associations\UrlAssociations\https\UserChoice" "Progid"  "IE.HTTPS"
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.html\UserChoice" "ProgId" "IE.AssocFile.HTM"
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.htm\UserChoice" "ProgId" "IE.AssocFile.HTM"
  ${ENDIF}	

  ; Refresh the desktop icons.
  System::Call "shell32::SHChangeNotify(i, i, i, i) v (0x08000000, 0, 0, 0)"
	; XP, protocol handlers do not always reset properly.  We will rebuild them.

  ReadRegstr $R0 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\IEXPLORE.EXE" ""
  ${IF} $USERADMIN  == "false"
    StrCpy $0 "SOFTWARE\Classes"
    SetShellVarContext Current
    WriteRegStr SHCTX "$0\HTTP\shell\open\command" "" '"$R0" -nohome'
    WriteRegStr	SHCTX "$0\HTTP\shell\open\ddeexec" "" '"%1",,-1,0,,,,'
    WriteRegStr	SHCTX "$0\HTTP\shell\open\ddeexec" "NoActivateHandler" ""
    WriteRegStr SHCTX "$0\HTTP\shell\open\ddeexec\Application" "" "IExplore"
    WriteRegStr SHCTX "$0\HTTP\shell\open\ddeexec\Topic" "" "WWW_OpenURL"
    WriteRegStr SHCTX "$0\HTTPS\shell\open\command" "" '"$R0" -nohome'
    WriteRegStr	SHCTX "$0\HTTPS\shell\open\ddeexec" "" '"%1",,-1,0,,,,'
    WriteRegStr	SHCTX "$0\HTTPS\shell\open\ddeexec" "NoActivateHandler" ""
    WriteRegStr SHCTX "$0\HTTPS\shell\open\ddeexec\Application" "" "IExplore"
    WriteRegStr SHCTX "$0\HTTPS\shell\open\ddeexec\Topic" "" "WWW_OpenURL"
  ${ELSE}
    WriteRegStr HKCR "HTTP\shell\open\command" "" '"$R0" -nohome'
    WriteRegStr	HKCR "HTTP\shell\open\ddeexec" "" '"%1",,-1,0,,,,'
    WriteRegStr	HKCR "HTTP\shell\open\ddeexec" "NoActivateHandler" ""
    WriteRegStr HKCR "HTTP\shell\open\ddeexec\Application" "" "IExplore"
    WriteRegStr HKCR "HTTP\shell\open\ddeexec\Topic" "" "WWW_OpenURL"
    WriteRegStr HKCR "HTTPS\shell\open\command" "" '"$R0" -nohome'
    WriteRegStr	HKCR "HTTPS\shell\open\ddeexec" "" '"%1",,-1,0,,,,'
    WriteRegStr	HKCR "HTTPS\shell\open\ddeexec" "NoActivateHandler" ""
    WriteRegStr HKCR "HTTPS\shell\open\ddeexec\Application" "" "IExplore"
    WriteRegStr HKCR "HTTPS\shell\open\ddeexec\Topic" "" "WWW_OpenURL"
  ${ENDIF}	  

  ;WriteRegStr HKCU "SOFTWARE\Clients\StartMenuInternet" "" "IEXPLORE.EXE"
  WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet" "" "IEXPLORE.EXE"
  
  ; Launch the current default browser with our uninstall url
  Push "LAUNCHUNINSTALL"
  Push "YES"
  Call un.GetParameterValue
  Pop $R0
  StrCmp $R0 "NO" SkipUninstallUrl LaunchUninstallUrl
  LaunchUninstallUrl:
  ReadRegstr $R0 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\IEXPLORE.EXE" ""
  Exec '$\"$R0$\" ${PRODUCT_UNINST_URL}'
  SkipUninstallUrl:
  System::Call "shell32::SHChangeNotify(i, i, i, i) v (0x08000000, 0, 0, 0)"
SectionEnd

!include "installer-functions.nsi"

;Function un.onUninstSuccess
;  HideWindow
;  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
;FunctionEnd

Function un.onInit
   Call un.GetWindowsVersion
   Pop $R0

 ; MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
 ; Abort
FunctionEnd

Function .Oninit

   System::Call 'kernel32::CreateMutexA(i 0, i 0, t "${PRODUCT_NAME}wrapper") i .r1 ?e'
   Pop $R0
   StrCmp $R0 0 +3
   MessageBox MB_OK|MB_ICONEXCLAMATION "The installer is already running."
   Abort
   Push $R0
   Call appCheck
   Call GetWindowsVersion
   Pop $R0
   StrCmp $R0 '95' NotSupported
   StrCmp $R0 'NT' NotSupported
   Goto OSok
  NotSupported:
   MessageBox MB_OK "${UNSUPPORTED}"
   Abort
  OSok:
   Call GetSysReqs
   Call DetermineInstallDir
   Call CheckForExistingInstall

    ; Extract InstallOptions INI files
    InitPluginsDir

    !insertmacro MUI_INSTALLOPTIONS_EXTRACT "config.ini"
    !insertmacro MUI_INSTALLOPTIONS_EXTRACT "graphics\\installPanel.bmp"
    File "/oname=$PLUGINSDIR\installPanel.bmp" "graphics\\installPanel.bmp"
    WriteIniStr $PLUGINSDIR\config.ini "Field 8" "Text" "$PLUGINSDIR\installPanel.bmp"
FunctionEnd
