; MUI 1.67 compatible ------
   !include "MUI.nsh"
   !include "LogicLib.nsh"

   !define PRODUCT_NAME "Flock Configuration Tool"
   !define PRODUCT_VERSION "1.0"

   !define APPNAME "Flock"               ; traditional Flock registry key
   !define PRGNAME "Flock"                       ; name of Start Menu|Program folder
   !define PRGLNK  "${APPNAME}.lnk"           ; name of shortcut
   !define EXENAME "FLOCK\FLOCK.EXE"                  ; name of browser executable
   !define APP_NAME "flock.exe"
   Var COMMAND
   Var EXELOCATION
   VAR CURRENTVERSION
   VAR RAWVERSION
   Var OS
   Var NT
   Var USERADMIN
   SilentInstall Silent

; MUI Settings
   !define MUI_ABORTWARNING
   !define MUI_ICON "flock.ico"

; Language files
   !insertmacro MUI_LANGUAGE "English"

   Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
   OutFile "flset.exe"
   ShowInstDetails hide

Section "MainSection" SEC01

   SetSilent Silent
   
   ; Return the currently installed path for flock.
    ReadRegStr $EXELOCATION HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\Flock.exe" "PATH"

   ; Strip this path to the base install level (ie, to Program Files/Flock)
    Strcpy $R1 $EXELOCATION 3
    Strcpy $R2 $EXELOCATION "" 3
    Push $R2
    Call GetParent
    Pop $R0
    StrCpy $EXELOCATION $R1$R0
    POP $R1
    Pop $R1

    ; Get the short filename version of this path
    ; this is done for compatibility reasons.
    GetFullPathName /SHORT $INSTDIR $EXELOCATION

    ; Uppercase this path
   Push $INSTDIR
    Call StrUpper
   Pop $INSTDIR

   ReadRegStr $CURRENTVERSION HKLM "SOFTWARE\Flock\Flock" "CurrentVersion"
   StrCpy $RAWVERSION $CURRENTVERSION -7

   Push $COMMAND
    Call StrUpper
   Pop $COMMAND 
   ;Messagebox MB_OK "$COMMAND"
   ${IF} ${FileExists} "$INSTDIR\${EXENAME}"
    ${SELECT} $COMMAND
    ${CASE} "/SHOWSHORTCUTS"
     SetShellVarContext All
     CreateShortCut "$DESKTOP\${PRGLNK}" "$INSTDIR\${EXENAME}" "" "$INSTDIR\${EXENAME}" 0
     CreateShortCut "$QUICKLAUNCH\${PRGLNK}" "$INSTDIR\${EXENAME}" "" "$INSTDIR\${EXENAME}" 0
     WriteRegDword HKLM "SOFTWARE\Clients\StartMenuInternet\${APPNAME}\InstallInfo" "IconsVisible" "1"

    ${CASE} "/HIDESHORTCUTS"
     SetShellVarContext All
     Delete "$QUICKLAUNCH\${PRGLNK}"
     Delete "$DESKTOP\${PRGLNK}"
     WriteRegDword HKLM "SOFTWARE\Clients\StartMenuInternet\${APPNAME}\InstallInfo" "IconsVisible" "0"

    ${CASE} "/SETASDEFAULTAPPGLOBAL"
    DeleteRegKey HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}" "" "Flock"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\DefaultIcon" "" '$INSTDIR\${EXENAME},0'
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\shell\open\command\" "" '$INSTDIR\${EXENAME}'
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\shell\properties" "" "Flock &Options"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\shell\properties\command\" "" '"$INSTDIR\${EXENAME} -preferences"'
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\shell\safemode" "" "Flock &Safe Mode"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\shell\safemode\command\" "" '"$INSTDIR\${EXENAME} -safe-mode"'

    WriteRegDword HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\InstallInfo" "IconsVisible" "1"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\InstallInfo" "HideIconsCommand" '"$INSTDIR\flock\uninstall\helper.exe" /HideShortcuts'
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\InstallInfo" "ReinstallCommand" '"$INSTDIR\flock\uninstall\helper.exe" /SetAsDefaultAppGlobal'
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\InstallInfo" "ShowIconsCommand" '"$INSTDIR\flock\uninstall\helper.exe" /ShowShortcuts'

    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities" "ApplicationDescription" "The Social Web Browser."
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities" "ApplicationIcon" "$$INSTDIR\${EXENAME},0"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities" "ApplicationName" "Flock"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\FileAssociations" ".htm"   "FlockHTML"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\FileAssociations" ".html"  "FlockHTML"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\FileAssociations" ".shtml" "FlockHTML"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\FileAssociations" ".xht"   "FlockHTML"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\FileAssociations" ".xhtml" "FlockHTML"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\URLAssociations" "ftp"    "FlockURL"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\URLAssociations" "gopher" "FlockURL"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\URLAssociations" "http"   "FlockURL"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\URLAssociations" "https"  "FlockURL"
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\${APP_NAME}\Capabilities\StartMenu" "StartMenuInternet" "FLOCK.EXE"

  GetFullPathName /SHORT $8 "$INSTDIR\${EXENAME}"
  StrCpy $0 "SOFTWARE\Classes"
  StrCpy $2 "$8 -requestPending -osint -url $\"%1$\""

  ${IF} $USERADMIN  == "false"
  SetShellVarContext Current
  ${ELSE}
  SetShellVarContext all
  ${ENDIF}
  
  ; Associate the file handlers with FlockHTML
  ;WriteRegStr SHCTX "$0\.htm"   "" "FlockHTML"
  ;WriteRegStr SHCTX "$0\.html"  "" "FlockHTML"
  ;WriteRegStr SHCTX "$0\.shtml" "" "FlockHTML"
  ;WriteRegStr SHCTX "$0\.xht"   "" "FlockHTML"
  ;WriteRegStr SHCTX "$0\.xhtml" "" "FlockHTML"
 
    WriteRegStr SHCTX "$0\FlockHTML" "" "Flock Document"
    WriteRegStr SHCTX "$0\FlockHTML" "FriendlyTypeName" "Flock Document"
    WriteRegStr SHCTX "$0\FlockHTML\DefaultIcon" "" '"$INSTDIR\${EXENAME}",1'
    WriteRegStr SHCTX "$0\FlockHTML\shell\open\command" "" "$INSTDIR\${EXENAME} -requestPending -osint -url $\"%1$\""
    WriteRegStr SHCTX "$0\FlockHTML\shell\open\ddeexec" "" ""
    WriteRegStr SHCTX "$0\FlockHTML\shell\open\ddeexec" "NoActivateHandler" ""
    WriteRegStr SHCTX "$0\FlockHTML\shell\open\ddeexec\Application" "" "Flock"
    WriteRegStr SHCTX "$0\FlockHTML\shell\open\ddeexec\Topic" "" "WWW_OpenURL"

    WriteRegStr SHCTX "$0\FlockURL" "" "Flock URL"
    WriteRegStr SHCTX "$0\FlockURL" "FriendlyTypeName" "Flock URL"
    WriteRegStr SHCTX "$0\FlockURL" "URL Protocol" ""
    WriteRegDword SHCTX "$0\FlockURL" "EditFlags" "2"
    WriteRegStr SHCTX "$0\FlockURL\DefaultIcon" "" '"$INSTDIR\${EXENAME}",1'
    WriteRegStr SHCTX "$0\FlockURL\shell\open\command" "" "$INSTDIR\${EXENAME} -requestPending -osint -url $\"%1$\""
    WriteRegStr SHCTX "$0\FlockURL\shell\open\ddeexec" "" ""
    WriteRegStr SHCTX "$0\FlockURL\shell\open\ddeexec" "NoActivateHandler" ""
    WriteRegStr SHCTX "$0\FlockURL\shell\open\ddeexec\Application" "" "Flock"
    WriteRegStr SHCTX "$0\FlockURL\shell\open\ddeexec\Topic" "" "WWW_OpenURL"

    WriteRegStr HKLM "SOFTWARE\RegisteredApplications" "Flock" "Software\Clients\StartMenuInternet\flock.exe\Capabilities"
   SetShellVarContext all
    WriteRegStr HKLM "SOFTWARE\Clients\StartMenuInternet\" "" "FLOCK.EXE"
    System::Call "shell32::SHChangeNotify(i, i, i, i) v (0x08000000, 0, 0, 0)"
    ${CaseELSE}
     quit
   ${EndSelect}
   ${ELSE}
    quit
   ${ENDIF}

   SendMessage ${HWND_BROADCAST} ${WM_SETTINGCHANGE} 0 "Software\Clients\StartMenuInternet" $R0
SectionEnd

Section -Post
   SetAutoClose true
SectionEnd

; Functions

Function .onInit
   Call GetParameters
   POP $COMMAND
   Call GetWindowsVersion
   
   ;MessageBox MB_OK "$COMMAND | $cmdline | $INSTDIR"

FunctionEnd

 ; GetParameters
 ; input, none
 ; output, top of stack (replaces, with e.g. whatever)
 ; modifies no other variables.

 Function GetParameters

   Push $R0
   Push $R1
   Push $R2
   Push $R3

   StrCpy $R2 1
   StrLen $R3 $CMDLINE

   ;Check for quote or space
   StrCpy $R0 $CMDLINE $R2
   StrCmp $R0 '"' 0 +3
     StrCpy $R1 '"'
     Goto loop
   StrCpy $R1 " "

   loop:
     IntOp $R2 $R2 + 1
     StrCpy $R0 $CMDLINE 1 $R2
     StrCmp $R0 $R1 get
     StrCmp $R2 $R3 get
     Goto loop

   get:
     IntOp $R2 $R2 + 1
     StrCpy $R0 $CMDLINE 1 $R2
     StrCmp $R0 " " get
     StrCpy $R0 $CMDLINE "" $R2

   Pop $R3
   Pop $R2
   Pop $R1
   Exch $R0

 FunctionEnd

; StrUpper
;   Converts the string on the stack to uppercase (in an ASCII sense)
; Usage:
;   Push <string>
;   Call StrUpper
;   Pop <STRING>
Function StrUpper
  Exch $0 ; Original string
  Push $1 ; Final string
  Push $2 ; Current character
  Push $3
  Push $4
  StrCpy $1 ""
Loop:
  StrCpy $2 $0 1 ; Get next character
  StrCmp $2 "" Done
  StrCpy $0 $0 "" 1
  StrCpy $3 65 ; 65 = ASCII code for A
Loop2:
  IntFmt $4 %c $3 ; Get character from current ASCII code
  StrCmp $2 $4 Match
  IntOp $3 $3 + 1
  StrCmp $3 91 NoMatch Loop2 ; 91 = ASCII code one beyond Z
Match:
  StrCpy $2 $4 ; It 'matches' (either case) so grab the uppercase version
NoMatch:
  StrCpy $1 $1$2 ; Append to the final string
  Goto Loop
Done:
  StrCpy $0 $1 ; Return the final string
  Pop $4
  Pop $3
  Pop $2
  Pop $1
  Exch $0
FunctionEnd

Function GetParent

  Exch $R0
  Push $R1
  Push $R2
  Push $R3

  StrCpy $R1 0
  StrLen $R2 $R0

  loop:
    IntOp $R1 $R1 + 1
    IntCmp $R1 $R2 get 0 get
    StrCpy $R3 $R0 1 -$R1
    StrCmp $R3 "\" get
  Goto loop

  get:
    StrCpy $R0 $R0 -$R1

    Pop $R3
    Pop $R2
    Pop $R1
    Exch $R0

FunctionEnd

 ; GetWindowsVersion Function
 ; Usage:
 ;   Call GetWindowsVersion
 ;   Pop $R0
 ;   ; at this point $R0 is "NT 4.0" or whatnot

Function GetWindowsVersion

   Push $R0
   Push $R1

   ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
   IfErrors 0 lbl_winnt

   ; we are not NT
   ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion" VersionNumber
   StrCPY $OS '9X'
   StrCpy $R1 $R0 1
   StrCmp $R1 '4' 0 lbl_error
   StrCpy $R1 $R0 3
   StrCmp $R1 '4.0' lbl_win32_95
   StrCmp $R1 '4.9' lbl_win32_ME lbl_win32_98

   lbl_win32_95:
     StrCpy $R0 '95'
   Goto lbl_done

   lbl_win32_98:
     StrCpy $R0 '98'
   Goto lbl_done

   lbl_win32_ME:
     StrCpy $R0 'ME'
   Goto lbl_done


   lbl_winnt:

   StrCpy $R1 $R0 1
   StrCPY $OS 'NT'
   StrCmp $R1 '3' lbl_winnt_x
   StrCmp $R1 '4' lbl_winnt_x
   StrCpy $R1 $R0 3
   StrCmp $R1 '5.0' lbl_winnt_2000
   StrCmp $R1 '5.1' lbl_winnt_XP
   StrCmp $R1 '5.2' lbl_winnt_2003
   StrCmp $R1 '6.0' lbl_winnt_vista lbl_error

   lbl_winnt_x:
     StrCpy $R0 'NT'
   Goto lbl_done

   lbl_winnt_2000:
     Strcpy $R0 '2000'
     Call IsUserAdmin
     pop $USERADMIN
   Goto lbl_done

   lbl_winnt_XP:
     Strcpy $R0 'XP'
     StrCPY $OS 'XP'
     Call IsUserAdmin
     pop $USERADMIN
   Goto lbl_done

   lbl_winnt_2003:
     Strcpy $R0 '2003'
     StrCPY $OS 'XP'
     Call IsUserAdmin
     pop $USERADMIN
   Goto lbl_done

   lbl_winnt_vista:
     Strcpy $R0 'Vista'
     StrCPY $OS 'VS'
     Call IsUserAdmin
     pop $USERADMIN
   Goto lbl_done

   lbl_error:
     Strcpy $R0 ''
     StrCPY $OS 'XX'
   lbl_done:

   Pop $R1
   Exch $R0

FunctionEnd
Function IsUserAdmin
Push $R0
Push $R1
Push $R2

ClearErrors
UserInfo::GetName
IfErrors Win9x
Pop $R1
UserInfo::GetAccountType
Pop $R2

StrCmp $R2 "Admin" User_Admin Continue
User_Admin:
; Observation: I get here when running Win98SE. (Lilla)
; The functions UserInfo.dll looks for are there on Win98 too,
; but just don't work. So UserInfo.dll, knowing that admin isn't required
; on Win98, returns admin anyway. (per kichik)
; MessageBox MB_OK 'User "$R1" is in the Administrators group'
StrCpy $R0 "true"
StrCpy $NT "1"
Goto UaDone

Continue:
; You should still check for an empty string because the functions
; UserInfo.dll looks for may not be present on Windows 95. (per kichik)
StrCmp $R2 "" Win9x
StrCpy $R0 "false"
StrCpy $NT "0"
;MessageBox MB_OK 'User "$R1" is in the "$R2" group'
Goto UaDone

Win9x:
; comment/message below is by UserInfo.nsi author:
; This one means you don't need to care about admin or
; not admin because Windows 9x doesn't either
;MessageBox MB_OK "Error! This DLL can't run under Windows 9x!"
StrCpy $R0 "true"
StrCpy $NT "0"

UaDone:
;MessageBox MB_OK 'User= "$R1"  AccountType= "$R2"  IsUserAdmin= "$R0"'

Pop $R2
Pop $R1
Exch $R0
FunctionEnd
