/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/*
 * BEGIN FLOCK GPL
 *
 * Copyright Flock Inc. 2005-2008
 * http://flock.com
 *
 * This file may be used under the terms of the
 * GNU General Public License Version 2 or later (the "GPL"),
 * http://www.gnu.org/licenses/gpl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * END FLOCK GPL
 */

#include "nsNativeAppSupportGtk.h"

NS_INTERFACE_MAP_BEGIN(nsNativeAppSupportGtk)
NS_INTERFACE_MAP_END_INHERITING(nsNativeAppSupportBase)

NS_IMPL_ADDREF_INHERITED(nsNativeAppSupportGtk, nsNativeAppSupportBase)
NS_IMPL_RELEASE_INHERITED(nsNativeAppSupportGtk, nsNativeAppSupportBase)

// Create and return an instance of class nsNativeAppSupportGtk.
nsresult
NS_CreateNativeAppSupport( nsINativeAppSupport **aResult ) {
    nsNativeAppSupportGtk *pNative = new nsNativeAppSupportGtk;
    if (!pNative) return NS_ERROR_OUT_OF_MEMORY;

    *aResult = pNative;
    NS_ADDREF( *aResult );

    return NS_OK;
}
/*
nsresult
nsNativeAppSupportGtk::SetupSysTrayIcon() {
  mTrayIcon = egg_tray_icon_create("flock-app");
  return NS_OK;
}

nsresult
nsNativeAppSupportGtk::RemoveSysTrayIcon() {
  egg_tray_icon_destroy();
  mTrayIcon = NULL;
  return NS_OK;
}
*/

nsresult
nsNativeAppSupportGtk::CreateSplashScreen() {
  if (mDialog)
    return NS_OK;

  nsCAutoString path(PR_GetEnv("MOZILLA_FIVE_HOME"));

  if (path.IsEmpty()) {
    path.Assign("splash.xpm");
  } else {
    path.Append("/splash.xpm");
  }
  
  GdkPixmap* pmap =
    gdk_pixmap_colormap_create_from_xpm(NULL, gdk_colormap_get_system(), NULL,
                                        NULL, path.get());

  if (!pmap) {
    return NS_ERROR_FAILURE;
  }
  
  gint width, height;
  gdk_window_get_size(pmap, &width, &height);

  GdkWindowAttr attr;
  attr.window_type = GDK_WINDOW_TEMP;
  attr.wclass = GDK_INPUT_OUTPUT;
  attr.x = (gdk_screen_width() >> 1) - (width >> 1);
  attr.y = (gdk_screen_height() >> 1) - (height >> 1);
  attr.width = width;
  attr.height = height;
  attr.event_mask = GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK;
  mDialog = gdk_window_new(NULL, &attr, GDK_WA_X | GDK_WA_Y);

  gdk_window_set_back_pixmap(mDialog, pmap, FALSE);
  gdk_pixmap_unref(pmap);

  return NS_OK; 
}

nsresult
nsNativeAppSupportGtk::ShowSplashScreen() {
  if (mDialog) {
    gdk_window_show(mDialog);
  }
  return NS_OK; 
}

nsresult
nsNativeAppSupportGtk::HideSplashScreen() {
  if (mDialog) {
    gdk_window_hide(mDialog);
  }
  return NS_OK;
}

nsresult
nsNativeAppSupportGtk::CloseSplashScreen() {
  if (mDialog) {
    gdk_window_destroy(mDialog);
    mDialog = nsnull;
  }
  return NS_OK;
}
